!     Last change:  JA   12 Jul 2008    6:04 pm
 !Name:GlobaleVariable
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: This module contains the globale variables used throughout the program
 !Variables of importance:  PROP=PROPERTIES  TC=TERMAL CONDUCTANCE  C=SPESIFIC HEAT
 MODULE GlobaleVariable
      IMPLICIT NONE
      !Variables for the implicit routine:
      INTEGER, DIMENSION(5,1000,50)          :: boundNU,boundSU,boundWU,boundEU
      DOUBLE PRECISION, DIMENSION(7,1000,50) :: boundN,boundS,boundW,boundE
      DOUBLE PRECISION                       :: konvergenskrit,precisionP
      DOUBLE PRECISION, DIMENSION(35000)     :: TEMPo
      !Variables for the Pyrolysis and recession:
      INTEGER                                :: NIFACE,NBFACE,NMEK,Pyrini,MREG,pyrolyse,M_EROSION
      INTEGER,DIMENSION(50)                  :: AM_ANTPYR
      INTEGER, DIMENSION(35000)              :: ANTPYR,IFACE,IFACEBULK,MEKSTART
      DOUBLE PRECISION, DIMENSION(200)       :: MEKTIMES,MEK
      DOUBLE PRECISION, DIMENSION(20,35000)  :: RHO,RHOO,RHOR,APYR,NPYR,TREAC,EPYR,VOLFRAC
      DOUBLE PRECISION                       :: IFACEVALUE
      DOUBLE PRECISION, DIMENSION(35000)     :: Angles,XCP,YCP,VX,VY,VMX,VMY,MI,MJ,MPYR,CPG,DHPYR,MEKRHOTOT, &
                                                MEKALFA,LENIBFACE,LENIBCELL,IBFACEX,IBFACEY,RHOFRAC,RHOOTOT, &
                                                RHORTOT,MEKTIME,MEKTIMED,MEKEND
      !Variables for input
      INTEGER, DIMENSION(20,30)              :: M_DATA,M_TEMP,M_TCI,M_TCJ,M_CP,M_RO
      DOUBLE PRECISION, DIMENSION(20,30)     :: AM_TEMP,AM_TCI,AM_CP,AM_RO,AM_TCJ,AM_RHOO,AM_RHOR,AM_APYR,AM_EPYR, &
                                                AM_NPYR,AM_TREAC,AM_CPG,AM_DHPYR,AM_VOLFRAC,AM_CPR, &
                                                AM_TCIR,AM_TCJR
      !Variables for time,grid,material properties ect.
      DOUBLE PRECISION                       :: TIME,TSF,CFL,DTIME,TSTART,TSTOP,TIMEP,DTPROBE,TIMEPP,DTPROBEP
      INTEGER, DIMENSION(20)                 :: IMPT,I0PT,J0PT,IDPT,NPPT
      INTEGER                                :: NMESH,NPROBE,MODE,NREG,NIF,NBND
      INTEGER, DIMENSION(50)                 :: NMP,NI,NJ,IMAIF,I0AIF,J0AIF,IDAIF,NPAIF,IMBIF,     &
                                                I0BIF,J0BIF,IDBIF,NPBIF
      DOUBLE PRECISION, DIMENSION(200)       :: AM_DATA,TPROBE
      DOUBLE PRECISION, DIMENSION(35000)     :: XM,YM,SIX,SIY,SJX,SJY,AI,AJ,DI,DJ,VOL,RO,TCI,TCJ,C,RI,RJ,Su, &
                                                TEMP,DTEMP,DQ
      INTEGER, DIMENSION(200)                :: IMP,IP,JP,IMR,IR1,IR2,JR1,JR2,IMAT
      INTEGER, DIMENSION(35000)              :: MAT
      INTEGER, DIMENSION(200)                :: IMBND,I0BND,J0BND,IDBND,NPBND,ITBND,IRADBND
      DOUBLE PRECISION, DIMENSION(50,500)    :: ROBND,UBND,VISCBND,CPBND,PRBND,TRBND,HCEBND,ALBND
      DOUBLE PRECISION, DIMENSION(500)       :: HCBND,TUBND,QBND,DTHCBND,DTTUBND,EMSBND,TRADBND
      DOUBLE PRECISION                       :: GCNT,RGAS,PRND,VISC,SCALEMESH
      INTEGER                                :: ISUP,NPROBEP
      DOUBLE PRECISION                       :: PTOT,TTOT,ATHROAT,PI
      CHARACTER                              :: MATRFIL*32

END MODULE GlobaleVariable

 !Name: G2DHeat
 !Author: Jrn Riise, *
 !Date: 30-06-2008
 !Description: Simulation program for heat transfer in solids.

      PROGRAM G2DHeat
      USE GlobaleVariable
      implicit none
      !Local variables
      INTEGER           :: ICOUNTP,ILOG,IPROBEP,IFIL,I,J,K,IMESH,NMPL,  &
                           NIL,NJL,LP,NSTEP,ISTEP,K1,istat,istatt,steps,MatID,IM, &
                           Istart,Iend,Jstart,Jend,IREG,t_start,t_stop,PREG
      DOUBLE PRECISION  :: RTHROAT,TINITIAL,T_TEMP,T_TCI,T_CP,T_RO,T_TCJ,kildeSu,T_CPR, &
                           T_RHOO,T_RHOR,T_APYR,T_EPYR,T_NPYR,T_TREAC,T_CPG,T_DHPYR,T_VOLFRAC, &
                           T_TCIR,T_TCJR
      REAL              :: TEMPtmp,TCItmp,TCJtmp,RHOtmp,xmm,MPYRtmp,VXtmp,VYtmp
      CHARACTER EVENT*32,TEXT*32

      !Initialize variables
      NIF=0
      NPROBE=0
      NPROBEP=0
      ICOUNTP=0
      ILOG=0
      Su=Su*0
      SCALEMESH=1.
      PI=4.*ATAN(1.)
      !Pyrolysis:Decision variable for the interface
      IFACEVALUE=0
      !Identification parameters for the ablative material
      IFACEBULK=IFACEBULK*0
      !Pyrolysis gas flow in I- and J-direction
      MJ=MJ*0
      MI=MI*0

      !START LOOP FOR INPUT DATA
      call timer ( t_start)
      DO WHILE(.TRUE.)

      READ(5,'(A32)')EVENT
      IF(EVENT(1:1) .NE. '#')WRITE(6,'(A32)')EVENT
      
      IF(EVENT .EQ. 'END')THEN
        call timer ( t_stop )
        write(6,*) 'Elapsed CPU time = ', t_stop - t_start
        IF(NPROBEP.GT.0)THEN
          DO IPROBEP=1,NPROBEP
            IFIL=11+IPROBEP
            CLOSE(IFIL)
          ENDDO
          WRITE(6,*)'UPDATE MANUALLY NUMBER OF TIME POINTS ON DATAFILE'
          WRITE(6,*)'Number of time points, ICOUNTP =',ICOUNTP
        ENDIF
        CLOSE(10)
        STOP 'FINISHED'
      ENDIF

      IF(EVENT .EQ. 'SCALEMESH')THEN
        READ(5,*) SCALEMESH
      END IF

      IF(EVENT .EQ. 'GRID')THEN
        CALL GRID
      ENDIF

      IF(EVENT .EQ. 'METRICS')THEN
        READ(5,'(A32)')EVENT
        IF(EVENT .EQ. '2D')  MODE=0
        IF(EVENT .EQ. 'AXI') MODE=1
        CALL MTR
      ENDIF

!      IF(EVENT .EQ. 'THICKNESS')THEN
!        READ(5,*)DEPTH
!      ENDIF

      IF(EVENT.EQ.'LOGFILE')THEN
        ILOG=1
        READ(5,'(A32)') TEXT
        OPEN(10,FILE=TEXT,STATUS='UNKNOWN',FORM='FORMATTED')
      ENDIF

      IF(EVENT .EQ. 'DEFMAT')THEN
        READ(5,*)NREG
        DO 1 I=1,NREG
          READ(5,'(A32)')TEXT
          IF(TEXT .EQ. 'ALUMINIUM'    )IMAT(I)=1
          IF(TEXT .EQ. 'STEEL'        )IMAT(I)=2
          IF(TEXT .EQ. 'SIPH'         )IMAT(I)=3
          IF(TEXT .EQ. 'SIPH_COOL'    )IMAT(I)=11
          IF(TEXT .EQ. 'MOLYBDEN'     )IMAT(I)=4
          IF(TEXT .EQ. 'EPDM'         )IMAT(I)=5
          IF(TEXT .EQ. 'HOTGAS'       )IMAT(I)=6
          IF(TEXT .EQ. 'ARAMIDE-EPOXY')IMAT(I)=7
          IF(TEXT .EQ. 'PROPELLANT'   )IMAT(I)=8
          IF(TEXT .EQ. 'TITAN'        )IMAT(I)=9
          IF(TEXT .EQ. 'GRAPHITE'     )IMAT(I)=10
          IF(TEXT .EQ. 'CARBON'       )IMAT(I)=12
          IF(TEXT .EQ. 'TZM'          )IMAT(I)=13
          IF(TEXT .EQ. 'WL10'         )IMAT(I)=14
          IF(TEXT .EQ. 'GRAPHITE-IG11')IMAT(I)=15
          IF(TEXT .EQ. 'DLR_C-C/SiC')IMAT(I)=16

          READ(5,*)IMR(I),IR1(I),IR2(I),JR1(I),JR2(I)
    1   CONTINUE
        CALL DEFMATDATA        !BOR KANSKJE VARE EN EGEN FIL
        CALL MATERIALS
      ENDIF
      !*******************************************
      !Initializing material properties from file.
      !*******************************************
      IF(EVENT .EQ. 'DEFMATERIAL')THEN
         pyrolyse=0
         !Material properties
         READ(5,*)MREG
         DO I=1,MREG
           READ(5,'(A32)')TEXT
           OPEN(19,FILE=TEXT,STATUS='UNKNOWN',FORM='FORMATTED',ACTION='READ')
           istat=0
           steps=0
           READ(19,*)EVENT
           WRITE(6,*) 'Event: ',EVENT
           DO
              READ(19,91,IOSTAT=istat)T_TEMP,T_CP,T_TCI,T_TCJ,T_RO,T_CPG,T_CPR,T_TCIR,T_TCJR,T_DHPYR
              IF(istat.LT.0) EXIT
              steps=steps+1
              AM_TEMP(I,steps)=T_TEMP
              AM_CP(I,steps)=T_CP
              AM_TCI(I,steps)=T_TCI
              AM_TCJ(I,steps)=T_TCJ
              AM_RO(I,steps)=T_RO
              AM_CPG(I,steps)=T_CPG
              AM_TCIR(I,steps)=T_TCIR
              AM_TCJR(I,steps)=T_TCJR
              AM_DHPYR(I,steps)=T_DHPYR
              AM_CPR(I,steps)=T_CPR
           END DO
         AM_DATA(I)=steps
      91 FORMAT(G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3)
         CLOSE (19)
         END DO

         !Kinetic parameters for use in decomposition reactions
         READ(5,*)PREG
         DO I=1,PREG
           READ(5,'(A32)')TEXT
           OPEN(18,FILE=TEXT,STATUS='UNKNOWN',FORM='FORMATTED',ACTION='READ')
           istatt=0
           steps=0
           READ(18,*)EVENT
           WRITE(6,*)EVENT
           DO
              READ(18,491,IOSTAT=istatt)T_RHOO,T_RHOR,T_APYR,T_EPYR,T_NPYR,T_TREAC,T_VOLFRAC
              IF(istatt.LT.0) EXIT
              steps=steps+1
              AM_RHOO(steps,I)=T_RHOO
              AM_RHOR(steps,I)=T_RHOR
              AM_APYR(steps,I)=T_APYR
              AM_EPYR(steps,I)=T_EPYR
              AM_NPYR(steps,I)=T_NPYR
              AM_TREAC(steps,I)=T_TREAC
              AM_VOLFRAC(steps,I)=T_VOLFRAC
           END DO
         AM_ANTPYR(I)=steps
     491 FORMAT(G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3,TR1,G11.3)
         CLOSE (18)
         pyrolyse=1
         Pyrini=1
         END DO
         !Initializing identification parameters
         READ(5,*)NREG
         DO IREG=1,NREG
          READ(5,*)MatID,IM,Istart,Iend,Jstart,Jend
          NMPL=NMP(IM)
          NIL = NI(IM)
          DO J=Jstart,Jend-1
           DO I=Istart,Iend-1
             K=I+NIL*(J-1)+NMPL
             MAT(K)=MatID
             !(1 ->Ablative, -1 -> backup)
             IF(MatID.GT.PREG) THEN
              IFACEBULK(K)=-1
             ELSE
              IFACEBULK(K)=1
             END IF
           END DO
          END DO
         END DO

      END IF

      IF(EVENT .EQ. 'INTERFACES')THEN
        READ(5,*)NIF
        IF(NIF.NE.0)THEN
          DO 2 I=1,NIF
            READ(5,*)IMAIF(I),I0AIF(I),J0AIF(I),IDAIF(I),NPAIF(I)
            READ(5,*)IMBIF(I),I0BIF(I),J0BIF(I),IDBIF(I),NPBIF(I)
    2     CONTINUE
        END IF
      END IF

      IF(EVENT .EQ. 'INOUTBC')THEN
        READ(5,*)NBND
        IF(NBND.NE.0)THEN
          DO 3 I=1,NBND
            READ(5,*)IMBND(I),I0BND(I),J0BND(I),IDBND(I),NPBND(I),      &
                     ITBND(I),IRADBND(I)
            IF(ITBND(I).EQ.1) READ(5,*)HCBND(I),TUBND(I)        ! Varmeovergangstall + Gasstemperatur
            IF(ITBND(I).EQ.2)READ(5,*)QBND(I)                   ! Varmefluks
            IF(ITBND(I).EQ.3)THEN                               !
              READ(5,'(A32)')TEXT
              OPEN(1,FILE=TEXT,FORM='FORMATTED',STATUS='UNKNOWN')
              CALL GASDATA(1,I)
            ENDIF
            IF(ITBND(I).EQ.4)THEN
              READ(5,'(A32)')TEXT
              OPEN(1,FILE=TEXT,FORM='FORMATTED',STATUS='UNKNOWN')
              CALL GASDATA(2,I)
            ENDIF
            IF(ITBND(I).EQ.5)READ(5,*)HCBND(I),TUBND(I),DTHCBND(I),DTTUBND(I)  !V.overg. tall+gasstemp+rampe v.ovg.tall+rampe Tgass
            IF(IRADBND(I).EQ.1)READ(5,*)EMSBND(I),TRADBND(I)     ! Emissivitet + strlingstemperatur

!     1D isentropic nozzle flow used as input to heat coeff. computations
            IF(ITBND(I).EQ.6)THEN                                ! Isentropisk dysestrm
!       subsonic,   isup=0
!       supersonic, isup=1

              READ(5,*)PTOT,TTOT,RTHROAT,ISUP
              ATHROAT=PI*RTHROAT**2
              CALL GASDATA(3,I)
            ENDIF
            !Constant surface temperature
            IF(ITBND(I).EQ.7)READ(5,*)TUBND(I)
    3     CONTINUE
        END IF
      END IF

      IF(EVENT .EQ. 'GASDATA')THEN
        READ(5,*)GCNT,RGAS,PRND,VISC
      END IF

      IF(EVENT .EQ. 'TINIT')THEN
        READ(5,*)TINITIAL
          DO 4 IMESH=1,NMESH
          NMPL=NMP(IMESH)
          NIL = NI(IMESH)
          NJL = NJ(IMESH)
          DO 5 J=1,NJL-1
          DO 5 I=1,NIL-1
            K=I+NIL*(J-1)+NMPL
            TEMP(K)=TINITIAL

    5     CONTINUE
    4   CONTINUE
      ENDIF

      IF(EVENT .EQ. 'PROBES_T')THEN
        READ(5,'(A32)')TEXT
        OPEN(11,FILE=TEXT,FORM='FORMATTED',STATUS='UNKNOWN')
        READ(5,*) DTPROBE
        READ(5,*)NPROBE
        DO LP=1,NPROBE
          READ(5,*) IMP(LP),IP(LP),JP(LP)
        ENDDO
      ENDIF

      IF(EVENT .EQ. 'PROBES_PT')THEN
        READ(5,*) DTPROBEP
        READ(5,*)NPROBEP
        DO I=1,NPROBEP
          READ(5,'(A32)')TEXT
          IFIL=11+I
          OPEN(IFIL,FILE=TEXT,FORM='FORMATTED',STATUS='UNKNOWN')
          WRITE(IFIL,*) 'TITLE = "HEAT 2D data"'
          WRITE(IFIL,*) 'VARIABLES = "YM", "TIME", "TEMP"'
          READ(5,*)IMPT(I),I0PT(I),J0PT(I),IDPT(I),NPPT(I)
          WRITE(IFIL,*) 'ZONE I=',NPPT(I)-1,', J=',0,', F=POINT'
        END DO
      ENDIF

      IF(EVENT .EQ. 'CFL')THEN
        READ(5,*)CFL,TSTART,DTIME,TSTOP
        TIME=TSTART
        TIMEP=TSTART
        TIMEPP=TSTART
      ENDIF

      IF(EVENT .EQ. 'TRANSIENT')THEN
        READ(5,*)NSTEP
        DO 8 ISTEP=1,NSTEP
          CALL STEP(ISTEP)
          TIME=TIME+TSF*CFL
          !WRITE(6,*)ISTEP,TIME,TSF*CFL
          IF(NPROBE .GT. 0)THEN
            IF(TIME.GE.TIMEP)THEN
              TIMEP=TIMEP+DTPROBE
              DO LP=1,NPROBE
                I=IP(LP)
                J=JP(LP)
                IMESH=IMP(LP)
                K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
                TPROBE(LP+1)=TEMP(K1)
              END DO
              TPROBE(1)=TIME
              WRITE(11,555)(TPROBE(I),I=1,NPROBE+1)
            ENDIF
          ENDIF

          IF(NPROBEP .GT. 0)THEN
            IF(TIME.GE.TIMEPP)THEN
              TIMEPP=TIMEPP+DTPROBEP
              CALL WRITE_PROBESP(TIME)
             ICOUNTP=ICOUNTP+1
            ENDIF
          ENDIF
  555     FORMAT(F10.3,200F9.4)
          IF(TIME.GT.TSTOP) GOTO 99
    8   CONTINUE
        IF(ILOG.EQ.1)WRITE(10,*)                                        &
           'INCREASE NUMBER OF ITERATIONS, TIME,TSTOP=',TIME,TSTOP
        WRITE(6,*)'INCREASE NUMBER OF ITERATIONS, TIME,TSTOP=',TIME,TSTOP
        STOP
   99   CONTINUE
      ENDIF

      !*****************************
      !Initializing recession rates.
      !*****************************
      IF(EVENT .EQ. 'M_EROSION')THEN
        READ(5,*)NMEK
        DO I=1,NMEK
        READ(5,*)MEKTIMES(I),MEK(I)
        END DO
        M_EROSION=1
      END IF


      !**************************
      !Implicit solution routine.
      !**************************
      IF (EVENT .EQ. 'IMPLICIT') THEN
       READ(5,*)konvergenskrit,TSTART,DTIME,TSTOP
       !Initializing time parameters
       TIME=TSTART
       TIMEP=TSTART
       TIMEPP=TSTART

       !Initializing interfaces and boundaries
       CALL INIT_IMPLICIT

       !Initializing boundary conditions
       CALL BORDERS_IMPLICIT

       !Initializing Pyrolysis parameters
       IF(pyrolyse.EQ.1) CALL INIT_PYROLYSIS

       !Solution routine
       DO

          CALL IMPLICIT_
          TIME=TIME+DTIME

          !Saving data
          IF(NPROBE .GT. 0)THEN
            IF(TIME.GE.TIMEP)THEN
              TIMEP=TIMEP+DTPROBE
              DO LP=1,NPROBE
                I=IP(LP)
                J=JP(LP)
                IMESH=IMP(LP)
                K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
                TPROBE(LP+1)=TEMP(K1)
              END DO
              TPROBE(1)=TIME
              WRITE(11,551)(TPROBE(I),I=1,NPROBE+1)
            ENDIF
          ENDIF

          IF(NPROBEP .GT. 0)THEN
            IF(TIME.GE.TIMEPP)THEN
              TIMEPP=TIMEPP+DTPROBEP
              CALL WRITE_PROBESP(TIME)
             ICOUNTP=ICOUNTP+1
            ENDIF
          ENDIF
  551     FORMAT(F10.3,200F9.4)

          IF (TIME.GE.TSTOP) EXIT

       END DO
      END IF

      !***************************************************
      !Initializing selection parameter for the interface.
      !***************************************************
      IF (EVENT .EQ. 'PYROLYSIS') THEN
        READ(5,*)IFACEVALUE
      END IF

      !***********************************
      !Initializing heat source/sink term.
      !***********************************
      IF(EVENT .EQ. 'SOURCE')THEN
      READ(5,*)NREG
         DO IREG=1,NREG
          READ(5,*)IM,Istart,Iend,Jstart,Jend,kildeSu
          NMPL=NMP(IM)
          NIL = NI(IM)
          DO J=Jstart,Jend-1
           DO I=Istart,Iend-1
             K=I+NIL*(J-1)+NMPL
             Su(K)=kildeSu
           END DO
          END DO
         END DO


      END IF

      IF(EVENT .EQ. 'READSOL')THEN
        READ(5,'(A32)')TEXT
        OPEN(UNIT=8,FILE=TEXT,FORM='UNFORMATTED',STATUS='UNKNOWN')
        DO 23 IMESH=1,NMESH
          NMPL=NMP(IMESH)
          NIL = NI(IMESH)
          NJL = NJ(IMESH)
          DO 24 J=1,NJL-1
          DO 24 I=1,NIL-1
            K=I+NIL*(J-1)+NMPL
            READ(8) TEMPtmp,TCItmp,TCJtmp,xmm
            TEMP(K)=REAL(TEMPtmp,8)
            TCI(K)=REAL(TCItmp,8)/1000.
            TCJ(K)=REAL(TCJtmp,8)/1000.
            mat(k)=ifix(xmm)
   24     CONTINUE
   23   CONTINUE
        CLOSE(8)
      ENDIF


      IF (EVENT .EQ. 'SAVEMATR') THEN
         read(5,'(A32)')MATRFIL
         CALL MATRSAVE
      END IF

      IF(EVENT .EQ. 'SAVESOL')THEN
        READ(5,'(A32)')TEXT
        OPEN(UNIT=9,FILE=TEXT,FORM='UNFORMATTED',STATUS='UNKNOWN')
        DO 13 IMESH=1,NMESH
          NMPL=NMP(IMESH)
          NIL = NI(IMESH)
          NJL = NJ(IMESH)
          DO 14 J=1,NJL-1
          DO 14 I=1,NIL-1
            K=I+NIL*(J-1)+NMPL
            xmm=REAL(mat(k))
            TEMPtmp=REAL(TEMP(K),4)
            TCItmp=REAL(TCI(K),4)*1000.
            TCJtmp=REAL(TCJ(K),4)*1000.
            WRITE(9)TEMPtmp,TCItmp,TCJtmp,xmm
   14     CONTINUE
   13   CONTINUE
      ENDIF

      !*****************************************************
      !Saving the solution:DENSITIES, TEMPERATURES and Mpyr.
      !*****************************************************
      IF(EVENT .EQ. 'SAVERHO')THEN
        READ(5,'(A32)')TEXT
        OPEN(UNIT=15,FILE=TEXT,FORM='UNFORMATTED',STATUS='UNKNOWN')
        DO IMESH=1,NMESH
          NMPL=NMP(IMESH)
          NIL = NI(IMESH)
          NJL = NJ(IMESH)
          DO J=1,NJL-1
           DO I=1,NIL-1
            K=I+NIL*(J-1)+NMPL
            xmm=REAL(mat(k))
            RHOtmp=REAL(RO(K),4)
            TEMPtmp=REAL(TEMP(K),4)
            MPYRtmp=REAL(((-1)*(MPYR(K)/VOL(K))),4)
            WRITE(15)RHOtmp,TEMPtmp,MPYRtmp,xmm
           END DO
          END DO
         END DO
      END IF

      !****************************************************************
      !Saving the solution:VECTOR DIRECTIONS[RO,RU](Techplot) and Mpyr.
      !****************************************************************
      IF(EVENT .EQ. 'SAVEVECTOR')THEN
        READ(5,'(A32)')TEXT
        OPEN(UNIT=15,FILE=TEXT,FORM='UNFORMATTED',STATUS='UNKNOWN')
        DO IMESH=1,NMESH
          NMPL=NMP(IMESH)
          NIL = NI(IMESH)
          NJL = NJ(IMESH)
          DO J=1,NJL-1
           DO I=1,NIL-1
            K=I+NIL*(J-1)+NMPL
            xmm=REAL(mat(k))
            VXtmp=REAL(VX(K),4)
            VYtmp=REAL(VY(K),4)
            MPYRtmp=REAL(MPYR(K),4)
            WRITE(15)VXtmp,VYtmp,MPYRtmp,xmm
           END DO
          END DO
         END DO
      END IF

      !****************************************************************
      !Saving the solution:VECTOR DIRECTIONS[RO,RU](Techplot) and Mpyr.
      !****************************************************************
      IF(EVENT .EQ. 'SAVEM_EROSION')THEN
        READ(5,'(A32)')TEXT
        OPEN(UNIT=15,FILE=TEXT,FORM='UNFORMATTED',STATUS='UNKNOWN')
        DO IMESH=1,NMESH
          NMPL=NMP(IMESH)
          NIL = NI(IMESH)
          NJL = NJ(IMESH)
          DO J=1,NJL-1
           DO I=1,NIL-1
            K=I+NIL*(J-1)+NMPL
            xmm=REAL(mat(k))
            VXtmp=REAL(VMX(K),4)
            VYtmp=REAL(VMY(K),4)
            MPYRtmp=REAL(MPYR(K),4)
            WRITE(15)VXtmp,VYtmp,MPYRtmp,xmm
           END DO
          END DO
         END DO
      END IF

      !**********************************************************
      !Saving the solution: Gas flow I- and J-direction and Mpyr.
      !**********************************************************
      IF(EVENT .EQ. 'SAVEGAS')THEN
        READ(5,'(A32)')TEXT
        OPEN(UNIT=15,FILE=TEXT,FORM='UNFORMATTED',STATUS='UNKNOWN')
        DO IMESH=1,NMESH
          NMPL=NMP(IMESH)
          NIL = NI(IMESH)
          NJL = NJ(IMESH)
          DO J=1,NJL-1
           DO I=1,NIL-1
            K=I+NIL*(J-1)+NMPL
            xmm=REAL(mat(k))
            VXtmp=REAL(MI(K),4)
            VYtmp=REAL(MJ(K),4)
            MPYRtmp=REAL(MPYR(K),4)
            WRITE(15)VXtmp,VYtmp,MPYRtmp,xmm
           END DO
          END DO
         END DO
      END IF


      
      ENDDO

      CLOSE(11)
      STOP
      END !End input routine

      SUBROUTINE WRITE_PROBESP(tid)
      USE GlobaleVariable
      implicit none
      !Local variables
      INTEGER          :: ID,JD,IPROBEP,IFIL,IMS,I0S,J0S,IDS,NPIS,IPP,I, &
                          J,K,K1,K2,K3,K4
      DOUBLE PRECISION :: YC,tid!xc,
      DIMENSION ID(4),JD(4)
      DATA ID / 1, 0,-1, 0/
      DATA JD / 0, 1, 0,-1/ 
      DO 1 IPROBEP=1,NPROBEP
        IFIL=11+IPROBEP
        IMS=IMPT(IPROBEP)
        I0S=I0PT(IPROBEP)
        J0S=J0PT(IPROBEP)
        IDS=IDPT(IPROBEP)
        NPIS=NPPT(IPROBEP)
        DO 2 IPP=1,NPIS-1
          I=I0S+ID(IDS)*(IPP-1)
          J=J0S+JD(IDS)*(IPP-1)
          K=I+NI(IMS)*(J-1)+NMP(IMS)
          K1=I  +NI(IMS)*(J-1)+NMP(IMS)
          K2=I+1+NI(IMS)*(J-1)+NMP(IMS)
          K3=I  +NI(IMS)*(J-0)+NMP(IMS)
          K4=I+1+NI(IMS)*(J-0)+NMP(IMS)
          !XC=.25*(XM(K1)+XM(K2)+XM(K3)+XM(K4))
          YC=.25*(YM(K1)+YM(K2)+YM(K3)+YM(K4))
          WRITE(IFIL,*) REAL(YC*1000.,4),REAL(tid,4),REAL(TEMP(K))
    2   CONTINUE
    1 CONTINUE
      RETURN
      END

      SUBROUTINE GRID
      USE GlobaleVariable
      implicit none

      !Local variables
      INTEGER                  :: I,NTOT,NMESHtmp
      INTEGER, DIMENSION (50)  :: NMPtmp,NItmp,NJtmp
      REAL, DIMENSION (35000)  :: Xtmp,Ytmp
      CHARACTER TEXT*32

      READ(5,'(A32)') TEXT
      OPEN(7,FILE=TEXT,FORM='UNFORMATTED',STATUS='UNKNOWN')
      READ(7) NMESHtmp
      READ(7) (NMPtmp(I),NItmp(I),NJtmp(I),I=1,NMESHtmp)
      NTOT=NMPtmp(NMESHtmp)+NItmp(NMESHtmp)*NJtmp(NMESHtmp)
      READ(7)(Xtmp(I),Ytmp(I),I=1,NTOT)
      DO I=1,NTOT
        XM(I)=REAL(Xtmp(I),8)
        YM(I)=REAL(Ytmp(I),8)
      END DO
      CLOSE(7)
      NMESH=NMESHtmp
      DO I=1,NMESHtmp
         NMP(I)=NMPtmp(I)
         NI(I)=NItmp(I)
         NJ(I)=NJtmp(I)
      END DO
      RETURN
      END

      SUBROUTINE MTR
      USE GlobaleVariable
      implicit none

      !Local variables
      INTEGER          :: IMESH,I,J,K1,K2,K3,K4,IMMIN,IMIN,JMIN,IMMAX,  &
                          IMAX,JMAX
      DOUBLE PRECISION :: VMIN,VMAX
      VMIN=+1.E20
      VMAX=-1.E20
      DO 1 IMESH=1,NMESH
        DO 10 J=1,NJ(IMESH)                   ! scale grid
        DO 10 I=1,NI(IMESH)
          K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
          XM(K1)=XM(K1)*SCALEMESH
          YM(K1)=YM(K1)*SCALEMESH
   10   CONTINUE

        DO 2 J=1,NJ(IMESH)-1                   ! 2D METRICS
        DO 2 I=1,NI(IMESH)
          K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
          K3=K1+NI(IMESH)
          SIX(K1)= YM(K3)-YM(K1)
          SIY(K1)=-XM(K3)+XM(K1)
          AI(K1)=SQRT(SIX(K1)**2+SIY(K1)**2)
    2   CONTINUE
        DO 3 J=1,NJ(IMESH)
        DO 3 I=1,NI(IMESH)-1
          K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
          K2=K1+1
          SJX(K1)=-YM(K2)+YM(K1)
          SJY(K1)= XM(K2)-XM(K1)
          AJ(K1)=SQRT(SJX(K1)**2+SJY(K1)**2)
    3   CONTINUE

        DO 4 J=1,NJ(IMESH)-1                   ! DI,DJ BASED
        DO 4 I=1,NI(IMESH)-1                   ! ON 2D METRICS
          K1=I+NI(IMESH)*(J-1)+NMP(IMESH)        !+ volumes
          K2=K1+1
          K3=K1+NI(IMESH)
          K4=K3+1
          DJ(K1)=0.5*(SQRT(SIX(K1)**2+SIY(K1)**2)+SQRT(SIX(K2)**2+SIY(K2)**2))
          DI(K1)=0.5*(SQRT(SJX(K1)**2+SJY(K1)**2)+SQRT(SJX(K3)**2+SJY(K3)**2))

          IF(MODE.EQ.1)THEN
!            VOL(K1)=DEPTH*1./6.*((XM(K4)-XM(K1))*(YM(K3)**2-YM(K2)**2)  &
            VOL(K1)=1./6.*((XM(K4)-XM(K1))*(YM(K3)**2-YM(K2)**2)        &
                         -(XM(K3)-XM(K2))*(YM(K4)**2-YM(K1)**2)         &
                         +(XM(K4)*YM(K4)-XM(K1)*YM(K1))*(YM(K3)-YM(K2)) &
                         -(XM(K3)*YM(K3)-XM(K2)*YM(K2))*(YM(K4)-YM(K1)))
          ELSE
!            VOL(K1)=DEPTH*.5*((XM(K4)-XM(K1))*(YM(K3)-YM(K2))           &
            VOL(K1)=0.5*((XM(K4)-XM(K1))*(YM(K3)-YM(K2))                &
                        -(XM(K3)-XM(K2))*(YM(K4)-YM(K1)))
          ENDIF
          IF(VOL(K1) .LT. VMIN)THEN
            VMIN=VOL(K1)
            IMMIN=IMESH
            IMIN=I
            JMIN=J
          ENDIF
          IF(VOL(K1) .GT. VMAX)THEN
            VMAX=VOL(K1)
            IMMAX=IMESH
            IMAX=I
            JMAX=J
          ENDIF

    4   CONTINUE

        IF(MODE.EQ.1)THEN                       ! AXI- SYMMETRICAL
          DO 5 J=1,NJ(IMESH)-1                  ! OPTION
          DO 5 I=1,NI(IMESH)
            K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
            K3=K1+NI(IMESH)
            SIX(K1)= .5*(YM(K1)+YM(K3))*(YM(K3)-YM(K1))
            SIY(K1)=-.5*(YM(K1)+YM(K3))*(XM(K3)-XM(K1))
            AI(K1)=SQRT(SIX(K1)**2+SIY(K1)**2)
    5     CONTINUE
          DO 6 J=1,NJ(IMESH)
          DO 6 I=1,NI(IMESH)-1
            K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
            K2=K1+1
            SJX(K1)=-.5*(YM(K1)+YM(K2))*(YM(K2)-YM(K1))
            SJY(K1)= .5*(YM(K1)+YM(K2))*(XM(K2)-XM(K1))
            AJ(K1)=SQRT(SJX(K1)**2+SJY(K1)**2)
    6     CONTINUE
        ENDIF

    1 CONTINUE
      WRITE(6,*)' MIN VOLUME:  ',IMMIN,IMIN,JMIN,VMIN
      WRITE(6,*)' MAX VOLUME:  ',IMMAX,IMAX,JMAX,VMAX
      RETURN
      END

      SUBROUTINE GASDATA(IOPT,IBOUND)
      USE GlobaleVariable
      implicit none
      INTEGER          :: IOPT,IBOUND

      !Local variables
      INTEGER          :: ID,JD,IBND,IM,I0,IPP,J0,IDR,NP,K0,KD,   &
                          K1,K2,I
      DOUBLE PRECISION :: ERRMAX,EPS,CPGAS,RFACT,FACT,WGFLOW,XPOS,   &
                          RADIUS,AREA,ARATIO,AM,AMN,DIFF,TC,PC,ROC,VEL, &
                          RE,F,ST

      DIMENSION ID(4),JD(4)
      DATA ID / 1, 0,-1, 0/ 
      DATA JD / 0, 1, 0,-1/

      PI=4.*ATAN(1.)
      ERRMAX=1.D-06
      EPS=1.D-06

      IF(IOPT.EQ.1)THEN
        WRITE(6,*)' IP     RO        V      VISC*1.E06   CP        PR ',&
                '       LENGTH'
        DO 1 IBND=1,NBND
          DO 2 IPP=1,NPBND(IBND)-1
            READ(1,*)ROBND(IBND,IPP), UBND(IBND,IPP),VISCBND(IBND,IPP),    &
                     CPBND(IBND,IPP),PRBND(IBND,IPP),  ALBND(IBND,IPP)
            WRITE(6,100)IPP,ROBND(IBND,IPP),UBND(IBND,IPP),                &
                        VISCBND(IBND,IPP)*1.E06,CPBND(IBND,IPP),          &
                        PRBND(IBND,IPP),ALBND(IBND,IPP)
    2     CONTINUE
    1   CONTINUE
      ENDIF
      IF(IOPT.EQ.2)THEN
        WRITE(6,*)' IP     TR       HC'
        IBND=IBOUND
      ENDIF

      !1D isentropic nozzle flow(input)
      IF(IOPT.EQ.3)THEN
        WRITE(6,*)' XPOS   AM        PC     TR       HC'
        CPGAS=GCNT*RGAS/(GCNT-1.)
        RFACT=PRND**.33333333
        FACT=.5*(GCNT+1.)/(GCNT-1.)
        WGFLOW=(2./(GCNT+1.))**FACT*SQRT(GCNT/RGAS/TTOT)*PTOT*ATHROAT
        IBND=IBOUND
        IM =IMBND(IBND)
        I0 =I0BND(IBND)
        J0 =J0BND(IBND)
        IDR=IDBND(IBND)
        NP =NPBND(IBND)
        K0 =I0        +NI(IM)*(J0        -1)+NMP(IM)
        !K0C=I0+IC(IDR)+NI(IM)*(J0+JC(IDR)-1)+NMP(IM)
        !K0I=I0        +NI(IM)*(J0+JC(IDR)-1)+NMP(IM)
        !K0J=I0+IC(IDR)+NI(IM)*(J0        -1)+NMP(IM)
        KD= ID(IDR)+NI(IM)* JD(IDR)
        DO 5 IPP=1,NP-1
          K1=K0+KD*(IPP-1)
          K2=K0+KD* IPP
          XPOS=.5*(XM(K1)+XM(K2))
          RADIUS=.5*(YM(K1)+YM(K2))
          AREA=PI*RADIUS**2
          ARATIO=AREA/ATHROAT
          IF(ARATIO.LT.1.0+EPS)THEN
            AM=1.0
            GOTO 10
          ENDIF

          !Subsonic
          IF(ISUP.EQ.0)THEN
            am=.5
            DO 6 I=1,200
              amn=(1.+.5*(gcnt-1.)*am**2)**fact*sqrt(rgas*ttot/gcnt)*   &
                  wgflow/ptot/area
              diff=abs(amn-am)/am
              am=amn
              IF(DIFF.LT.ERRMAX)GOTO 7
    6       CONTINUE
	    WRITE(6,*)'ITERATION FAILED, SUBSONIC'
    7       CONTINUE
          ENDIF

          !Supersonic
          IF(ISUP.EQ.1)THEN
            am=1.5
            DO 8 I=1,200
              amn=sqrt(2./(gcnt-1.)*((am/wgflow*ptot*area*              &
                  sqrt(gcnt/rgas/ttot))**(1./fact)-1.))
              diff=abs(amn-am)/am
              am=amn
	      IF(DIFF.LT.ERRMAX)GOTO 9
    8       CONTINUE
	    WRITE(6,*)'ITERATION FAILED, SUPERSONIC'
    9       CONTINUE
          ENDIF
   10     CONTINUE
 
          tc=ttot/(1.+.5*(gcnt-1.)*am**2)
          pc=ptot/(1.+.5*(gcnt-1.)*am**2)**(gcnt/(gcnt-1.))
          roc=pc/rgas/tc
          vel=wgflow/area/roc

          !Viscosity power law from SPP
          VISCBND(IBND,IPP)=VISC*(TC/TTOT)**.6728
          TRBND(IBND,IPP)=RFACT*TTOT+(1.-RFACT)*TC
          TRBND(IBND,IPP)=TRBND(IBND,IPP)-273.
          RE=WGFLOW*2/(PI*RADIUS*VISCBND(IBND,IPP))
          F=0.0791/(RE**0.25)
          ST=F/2/(1+1.99*RE**(-0.125)*(PRND-1))
          HCEBND(IBND,IPP)=ROC*VEL*ST*CPGAS

          WRITE(6,*)XPOS*1000.,AM,PC/1.E6,TRBND(IBND,IPP),HCEBND(IBND,IPP)
    5   CONTINUE
      ENDIF

      CLOSE(1)
  100 FORMAT(I4,6F10.3)
      RETURN
      END

      SUBROUTINE LTSP
      USE GlobaleVariable
      implicit none
      !Local variables
      INTEGER          :: IMESH,I,J,K1,K2,K3,printer
      DOUBLE PRECISION :: TMAX,TS
      printer=1
      TS=DTIME
      DO IMESH=1,NMESH
        DO J=1,NJ(IMESH)-1
        DO I=1,NI(IMESH)-1
          K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
          K2=K1+1
          K3=K1+NI(IMESH)
          TMAX=RO(K1)*C(K1)*VOL(K1)/((AI(K1)/RI(K1))+(AI(K2)/RI(K2))+(AJ(K1)/RJ(K1))+(AJ(K3)/RJ(K3)))
          IF (TS>TMAX) THEN
            TS=TMAX
            IF (printer.EQ.1) THEN
             WRITE(6,*) 'Time step has been changed, dt= ',TS
             printer=0
            END IF
          END IF
        END DO
        END DO
      END DO
      TSF=TS
      RETURN
      END

 !Name:IMPLICIT
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Solves the governing equation using TDMA line-by-line 2D.

       SUBROUTINE IMPLICIT_
       USE GlobaleVariable
       implicit none

       !Local variables
       INTEGER                             :: IMESH,K1,K2,K3,I,pos,J,K4,K5,dummy
       DOUBLE PRECISION, DIMENSION(1000)   :: ma,mb,mc,md,P,Q
       DOUBLE PRECISION                    :: tempP,tempPo,tempE,tempN,tempS,aw,ae,an,as,ap,kildeP,kildeU,apo, &
                                              denomiator,tempOLD,SIGMA,RADIATION,EMMIS
       LOGICAL                             :: ferdig

       SIGMA=5.67*1.E-08
       !Initializing convergence variable
       ferdig = .FALSE.

       !Pyrolysis decomposition reactions
       IF (pyrolyse.EQ.1) THEN
        CALL PYROLYSIS
        CALL CONTINUITY
       END IF

       !Temporary storage of temperatures
       TEMPo(:)=TEMP(:)

       DO

        dummy=1

        IF(ferdig) EXIT

        ferdig=.TRUE.

        !Updating material properties
        IF (pyrolyse.EQ.0) THEN
        CALL PICKMDATA
        END IF
        CALL RESMAT


       !Updating shadow cells
       CALL UPDATE_IMPLICIT

       !Sweeping(from South to North) in j-direction
       DO IMESH=1,NMESH
       DO J=1,NJ(IMESH)-1
        	DO I=1,NI(IMESH)-1
                        kildeP=0
                        kildeU=0
                        pos=I+1
                        !Coordinates in 1D-vector
                        K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
                        K2=K1+1
                        K3=K1+NI(IMESH)
                        K4=K1-NI(IMESH)
                        IF (J.EQ.1) THEN
                           !South edge
                           an=(AJ(K3)/RJ(K3))+(CPG(K1)*MAX(0.,(-MJ(K3))))
                           as=boundS(3,I,IMESH)
                           kildeU=boundS(5,I,IMESH)+(Su(K1)*VOL(K1))+(MPYR(K1)*DHPYR(K1))
                           !kildeP=0
                           RADIATION=boundS(6,I,IMESH)
                           EMMIS=boundS(7,I,IMESH)
                           IF (RADIATION.GT.0) THEN
                            kildeP=(-1)*boundS(1,I,IMESH)*SIGMA*EMMIS*(4*(TEMPo(K1)**3))
                            kildeU=kildeU+(boundS(1,I,IMESH)*SIGMA*EMMIS*(RADIATION+(3*(TEMPo(K1)**4))))
                           END IF

                           tempN=TEMP(K3)
                           tempS=boundS(4,I,IMESH)
                           tempPo=TEMPo(K1)
                        ELSE IF (J.EQ.(NJ(IMESH)-1)) THEN
                           !North edge
                           an=boundN(3,I,IMESH)
                           as=(AJ(K1)/RJ(K1))+(CPG(K1)*MAX(0.,MJ(K1)))
                           kildeU=boundN(5,I,IMESH)+(Su(K1)*VOL(K1))+(MPYR(K1)*DHPYR(K1))
                           RADIATION=boundN(6,I,IMESH)
                           EMMIS=boundN(7,I,IMESH)
                           IF (RADIATION.GT.0) THEN
                            kildeP=(-1)*boundN(1,I,IMESH)*SIGMA*EMMIS*(4*(TEMPo(K1)**3))
                            kildeU=kildeU+(boundN(1,I,IMESH)*SIGMA*EMMIS*(RADIATION+(3*(TEMPo(K1)**4))))
                           END IF

                           tempN=boundN(4,I,IMESH)
                           tempS=TEMP(K4)
                           tempPo=TEMPo(K1)

                        ELSE
                           !Internal cell volumes
                           an=(AJ(K3)/RJ(K3))+(CPG(K1)*MAX(0.,(-MJ(K3))))
                           as=(AJ(K1)/RJ(K1))+(CPG(K1)*MAX(0.,MJ(K1)))
                           kildeU=(Su(K1)*VOL(K1))+(MPYR(K1)*DHPYR(K1))

                           tempN=TEMP(K3)
                           tempS=TEMP(K4)
                           tempPo=TEMPo(K1)
                        END IF

                        IF (I.EQ.1) THEN
                           !West edge
                           aw=boundW(3,J,IMESH)
                           ae=(AI(K2)/RI(K2))+(CPG(K1)*MAX(0.,(-MI(K2))))
                           kildeU=kildeU+boundW(5,J,IMESH)

                           RADIATION=boundW(6,J,IMESH)
                           EMMIS=boundW(7,J,IMESH)
                           IF (RADIATION.GT.0) THEN
                            kildeP=(-1)*boundW(1,J,IMESH)*SIGMA*EMMIS*(4*(TEMPo(K1)**3))
                            kildeU=kildeU+(boundW(1,J,IMESH)*SIGMA*EMMIS*(RADIATION+(3*(TEMPo(K1)**4))))
                           END IF

                        ELSE IF (I.EQ.(NI(IMESH)-1)) THEN
                           !East edge
                           aw=(AI(K1)/RI(K1))+(CPG(K1)*MAX(0.,MI(K1)))
                           ae=boundE(3,J,IMESH)
                           kildeU=kildeU+boundE(5,J,IMESH)

                           RADIATION=boundE(6,J,IMESH)
                           EMMIS=boundE(7,J,IMESH)
                           IF (RADIATION.GT.0) THEN
                            kildeP=(-1)*boundE(1,J,IMESH)*SIGMA*EMMIS*(4*(TEMPo(K1)**3))
                            kildeU=kildeU+(boundE(1,J,IMESH)*SIGMA*EMMIS*(RADIATION+(3*(TEMPo(K1)**4))))
                           END IF
                        ELSE
                           aw=(AI(K1)/RI(K1))+(CPG(K1)*MAX(0.,MI(K1)))
                           ae=(AI(K2)/RI(K2))+(CPG(K1)*MAX(0.,(-MI(K2))))
                        END IF

                        !Cell + source
                        apo=(RO(K1)*C(K1)*VOL(K1))/DTIME
                        ap=apo+aw+ae+an+as-kildeP


                        !TDMA Part 1 (Forward substitution)

                        !Initial temperature West
                        IF (I.EQ.1) THEN
                           P(1)=0
                           Q(1)=boundW(4,J,IMESH)
                        END IF

                        !Internal coefficients
                        ma(pos)=ap
                        mb(pos)=ae
                        mc(pos)=aw
                        md(pos)=(an*tempN)+(as*tempS)+(apo*tempPo)+kildeU

                        !Forward substitution
                        denomiator=ma(pos)-(mc(pos)*P(pos-1))
                        P(pos)=mb(pos)/denomiator
                        Q(pos)=((mc(pos)*Q(pos-1))+md(pos))/denomiator

                END DO !End i and TDMA Part 11


                !TDMA Part 2 (Backward substitution)
                DO I=NI(IMESH)-1, 1, -1
                    pos=I+1
                    !Coordinates in 1D-vector
                    K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
                    K2=K1+1
                    K3=K1+NI(IMESH)
                    K4=K1-NI(IMESH)

                    !Initial temperature East
                    IF(I.EQ.(NI(IMESH)-1)) THEN
                    tempE=boundE(4,J,IMESH)
                    ELSE
                    tempE=temp(K2)
                    END IF

                    !Backward substitution
                    tempP=(P(pos)*tempE)+Q(pos)
                    temp(K1)=tempP

                END DO !End TDMA Part 2

                END DO !End j
       END DO !End imesh

       !Updating shadow cells
       CALL UPDATE_IMPLICIT

       !Sweeping(from West to East) in i-direction
       DO IMESH=1,NMESH
       DO I=1,NI(IMESH)-1
        	DO J=1,NJ(IMESH)-1
                        kildeP=0
                        kildeU=0
                        pos=J+1
                        !Coordinates in 1D-vector
                        K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
                        K2=K1+1
                        K3=K1+NI(IMESH)
                        K5=K1-1

                        IF (I.EQ.1) THEN
                           !North edge
                           an=boundW(3,J,IMESH)
                           as=(AI(K2)/RI(K2))+(CPG(K1)*MAX(0.,(-MI(K2))))
                           kildeU=boundW(5,J,IMESH)+(Su(K1)*VOL(K1))+(MPYR(K1)*DHPYR(K1))

                           RADIATION=boundW(6,J,IMESH)
                           EMMIS=boundW(7,J,IMESH)
                           IF (RADIATION.GT.0) THEN
                            kildeP=(-1)*boundW(1,J,IMESH)*SIGMA*EMMIS*(4*(TEMPo(K1)**3))
                            kildeU=kildeU+(boundW(1,J,IMESH)*SIGMA*EMMIS*(RADIATION+(3*(TEMPo(K1)**4))))
                           END IF

                           tempN=boundW(4,J,IMESH)
                           tempS=TEMP(K2)
                           tempPo=TEMPo(K1)
                        ELSE IF (I.EQ.(NI(IMESH)-1)) THEN
                           !South edge
                           an=(AI(K1)/RI(K1))+(CPG(K1)*MAX(0.,MI(K1)))
                           as=boundE(3,J,IMESH)
                           kildeU=boundE(5,J,IMESH)+(Su(K1)*VOL(K1))+(MPYR(K1)*DHPYR(K1))

                           RADIATION=boundE(6,J,IMESH)
                           EMMIS=boundE(7,J,IMESH)
                           IF (RADIATION.GT.0) THEN
                            kildeP=(-1)*boundE(1,J,IMESH)*SIGMA*EMMIS*(4*(TEMPo(K1)**3))
                            kildeU=kildeU+(boundE(1,J,IMESH)*SIGMA*EMMIS*(RADIATION+(3*(TEMPo(K1)**4))))
                           END IF

                           tempN=TEMP(K5)
                           tempS=boundE(4,J,IMESH)
                           tempPo=TEMPo(K1)
                        ELSE
                           !Internal cell volumes
                           an=(AI(K1)/RI(K1))+(CPG(K1)*MAX(0.,MI(K1)))
                           as=(AI(K2)/RI(K2))+(CPG(K1)*MAX(0.,(-MI(K2))))
                           kildeU=(Su(K1)*VOL(K1))+(MPYR(K1)*DHPYR(K1))

                           tempN=TEMP(K5)
                           tempS=TEMP(K2)
                           tempPo=TEMPo(K1)
                        END IF

                        IF (J.EQ.1) THEN
                           !West edge
                           ae=(AJ(K3)/RJ(K3))+(CPG(K1)*MAX(0.,(-MJ(K3))))
                           aw=boundS(3,I,IMESH)
                           kildeU=kildeU+boundS(5,I,IMESH)

                           RADIATION=boundS(6,I,IMESH)
                           EMMIS=boundS(7,I,IMESH)
                           IF (RADIATION.GT.0) THEN
                            kildeP=(-1)*boundS(1,I,IMESH)*SIGMA*EMMIS*(4*(TEMPo(K1)**3))
                            kildeU=kildeU+(boundS(1,I,IMESH)*SIGMA*EMMIS*(RADIATION+(3*(TEMPo(K1)**4))))
                           END IF
                        ELSE IF (J.EQ.(NJ(IMESH)-1)) THEN
                           !East edge
                           ae=boundN(3,I,IMESH)
                           aw=(AJ(K1)/RJ(K1))+(CPG(K1)*MAX(0.,MJ(K1)))
                           kildeU=kildeU+boundN(5,I,IMESH)

                           RADIATION=boundN(6,I,IMESH)
                           EMMIS=boundN(7,I,IMESH)
                           IF (RADIATION.GT.0) THEN
                            kildeP=(-1)*boundN(1,I,IMESH)*SIGMA*EMMIS*(4*(TEMPo(K1)**3))
                            kildeU=kildeU+(boundN(1,I,IMESH)*SIGMA*EMMIS*(RADIATION+(3*(TEMPo(K1)**4))))
                           END IF
                        ELSE
                           ae=(AJ(K3)/RJ(K3))+(CPG(K1)*MAX(0.,(-MJ(K3))))
                           aw=(AJ(K1)/RJ(K1))+(CPG(K1)*MAX(0.,MJ(K1)))
                        END IF

                        !Cell + source
                        apo=(RO(K1)*C(K1)*VOL(K1))/DTIME
                        ap=apo+aw+ae+an+as-kildeP

                        !TDMA Part 1 (Forward substitution)

                        !Initial temperature West
                        IF (J.EQ.1) THEN
                           P(1)=0
                           Q(1)=boundS(4,I,IMESH)
                        END IF

                        !Internal coefficients
                        ma(pos)=ap
                        mb(pos)=ae
                        mc(pos)=aw
                        md(pos)=(an*tempN)+(as*tempS)+(apo*tempPo)+kildeU

                        !Forward substitution
                        denomiator=(ma(pos)-(mc(pos)*P(pos-1)))
                        P(pos)=mb(pos)/denomiator
                        Q(pos)=((mc(pos)*Q(pos-1))+md(pos))/denomiator


                END DO !End j and TDMA part 1

                !TDMA Part 2 (Backward substitution)
                DO J=NJ(IMESH)-1, 1, -1
                    pos=J+1
                    !Coordinates in 1D-vector
                    K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
                    K2=K1+1
                    K3=K1+NI(IMESH)
                    K5=K1-1

                    !Initial temperature East
                    tempOLD=temp(K1)
                    IF(J.EQ.(NJ(IMESH)-1)) THEN
                    tempE=boundN(4,I,IMESH)
                    ELSE
                    tempE=temp(K3)
                    END IF

                    !Backward substitution
                    tempP=(P(pos)*tempE)+Q(pos)
                    temp(K1)=tempP

                    !Check for convergence
                    IF(ABS(tempOLD-tempP).GT.konvergenskrit) THEN
                        ferdig=.FALSE.
                    END IF !Check for convergence
                END DO !End TDMA Part 2

        END DO !End i
       END DO !End imesh


       END DO !End convergence

       END SUBROUTINE !End Implicit

 !Name: MECH_EROSION
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Calculates the starting and ending time of the recession

     SUBROUTINE MECH_EROSION
     USE GlobaleVariable
     implicit none

     DOUBLE PRECISION                    :: LENIFACE,TLENIFACE,IDX,IDY,deltaSF,deltaCP,xcross,ycross,ykCP,ykSF, &
                                            xcross1,ycross1,xcross2,ycross2,IDXX,IDYY,TLEN1,TLEN2,SUMMEK,MAXLEN, &
                                            LENIBFACED
     INTEGER                             :: K1,K2,K3,K4,I,J,K,IMESH,R,B,IBPKT,donemek,cross,TNMEK,startMEK,FIRST1,FIRST2
     DOUBLE PRECISION, DIMENSION(4)      :: dyB,dxB,XB,YB


     DO IMESH=1,NMESH
      DO I=1,NI(IMESH)-1
       DO J=1,NJ(IMESH)-1
          K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
          !For decomposing cell volumes
          IF(IFACEBULK(K1).GT.0) THEN
          !Calculates the recession vectors
            K2=K1+1
            K3=K1+NI(IMESH)
            K4=K3+1
            IDX=IBFACEX(1)-XCP(K1)
            IDY=IBFACEY(1)-YCP(K1)
            LENIFACE=SQRT((IDX**2)+(IDY**2))+1
            DO K=1,NBFACE
             IDX=IBFACEX(K)-XCP(K1)
             IDY=IBFACEY(K)-YCP(K1)
             TLENIFACE=SQRT((IDX**2)+(IDY**2))
             IF(TLENIFACE.LT.LENIFACE) THEN
              VMX(K1)=IDX
              VMY(K1)=IDY
              IBPKT=K
              LENIFACE=TLENIFACE
             END IF
            END DO
            !Center points on cell volume edges 1=south,2=east,3=north and 4=west
            dxB(1)=XM(K2)-XM(K1)
            dyB(1)=YM(K2)-YM(K1)
            dxB(2)=XM(K4)-XM(K2)
            dyB(2)=YM(K4)-YM(K2)
            dxB(3)=XM(K3)-XM(K4)
            dyB(3)=YM(K3)-YM(K4)
            dxB(4)=XM(K1)-XM(K3)
            dyB(4)=YM(K1)-YM(K3)
            XB(1)=XM(K1)
            YB(1)=YM(K1)
            XB(2)=XM(K2)
            YB(2)=YM(K2)
            XB(3)=XM(K4)
            YB(3)=YM(K4)
            XB(4)=XM(K3)
            YB(4)=YM(K3)


            FIRST1=0
            FIRST2=0
            DO R=1,4
             !Find the crossing points for recession length in cell volumes
             cross=0
             IF (ABS(VMX(K1)).GT.0) THEN
              deltaCP=(VMY(K1)/VMX(K1))
              ykCP=YCP(K1)-(deltaCP*XCP(K1))
              IF (ABS(dxB(R)).GT.0) THEN
               deltaSF=(dyB(R)/dxB(R))
               ykSF=YB(R)-(deltaSF*XB(R))
               IF (ABS(deltaSF-deltaCP).GT.0) THEN
                xcross=(ykSF-ykCP)/(deltaCP-deltaSF)
                ycross=ykSF+(deltaSF*xcross)
                cross=1
               END IF
              ELSE
                xcross=XB(R)
                ycross=ykCP+(deltaCP*xcross)
                cross=1
              END IF
             ELSE
              IF (ABS(dxB(R)).GT.0) THEN
               deltaSF=(dyB(R)/dxB(R))
               ykSF=YB(R)-(deltaSF*XB(R))
               xcross=XCP(K1)
               ycross=ykSF+(deltaSF*xcross)
               cross=1
              END IF
             END IF

             !If crossing point is found:
             IF (cross.EQ.1) THEN
               IF (ABS(VMX(K1)).GT.0) THEN
                IF (xcross.LT.XCP(K1)) THEN
                  IF (FIRST1.EQ.0) THEN
                   xcross1=xcross
                   ycross1=ycross
                   FIRST1=1
                  ELSE IF (xcross.GT.xcross1) THEN
                   xcross1=xcross
                   ycross1=ycross
                  END IF
                ELSE
                  IF (FIRST2.EQ.0) THEN
                   xcross2=xcross
                   ycross2=ycross
                   FIRST2=1
                  ELSE IF (xcross.LT.xcross2) THEN
                   xcross2=xcross
                   ycross2=ycross
                  END IF
                END IF
               ELSE
                IF (ycross.GT.YCP(K1)) THEN
                  IF (FIRST1.EQ.0) THEN
                   xcross1=xcross
                   ycross1=ycross
                   FIRST1=1
                  ELSE IF (ycross.GT.ycross1) THEN
                   xcross1=xcross
                   ycross1=ycross
                  END IF
                ELSE
                  IF (FIRST2.EQ.0) THEN
                   xcross2=xcross
                   ycross2=ycross
                   FIRST2=1
                  ELSE IF (ycross.LT.ycross2) THEN
                   xcross2=xcross
                   ycross2=ycross
                  END IF
                END IF
               END IF
             END IF

            END DO

            !Crossing points: xcross1 og xcross2
            IDX=IBFACEX(IBPKT)-xcross1
            IDY=IBFACEY(IBPKT)-ycross1
            TLEN1=SQRT((IDX**2)+(IDY**2))
            IDXX=IBFACEX(IBPKT)-xcross2
            IDYY=IBFACEY(IBPKT)-ycross2
            TLEN2=SQRT((IDXX**2)+(IDYY**2))
            !Calculates the length to start of recession and the length inside cell volume
            IF (TLEN1.LT.TLEN2) THEN
             LENIBFACE(K1)=TLEN1
             LENIBCELL(K1)=TLEN2-TLEN1
            ELSE
             LENIBFACE(K1)=TLEN2
             LENIBCELL(K1)=TLEN1-TLEN2
            END IF
            !Calculates starting and ending time of recession, erosjon VMEK()=m/s, NMEK=number of recession rates

              !**************
              !Starting time.
              !**************
              donemek=0
              startMEK=1
              TNMEK=NMEK !N ending times
              DO
               IF (donemek.EQ.1) EXIT
                 !Mean recession rate
                 SUMMEK=MEK(startMEK)*(MEKTIMES(startMEK))
                 IF (ABS(TNMEK-startMEK).GE.2) THEN
                  DO B=(startMEK+1),(TNMEK-1)
                   SUMMEK=SUMMEK+(MEK(B)*(MEKTIMES(B)-MEKTIMES(B-1)))
                  END DO
                 END IF
                 IF(TNMEK.EQ.1) THEN
                    MAXLEN=SUMMEK
                 ELSE
                    MAXLEN=SUMMEK+((MEKTIMES(TNMEK)-MEKTIMES(TNMEK-1))*MEK(TNMEK))
                 END IF
                 IF (MAXLEN.GT.LENIBFACE(K1)) THEN
                   IF(MEK(TNMEK).EQ.0) THEN
                    MEKTIME(K1)=0
                   ELSE IF(TNMEK.EQ.1) THEN
                    MEKTIME(K1)=(LENIBFACE(K1)/MEK(TNMEK))
                   ELSE
                    MEKTIME(K1)=((LENIBFACE(K1)-SUMMEK)/MEK(TNMEK))+MEKTIMES(TNMEK-1)
                   END IF
                 ELSE
                   MEKTIME(K1)=1.0E15
                   donemek=1
                 END IF

                 !Check for current recession
                 IF (MEKTIME(K1).LT.MEKTIMES(TNMEK-1)) THEN
                  TNMEK=TNMEK-1
                 ELSE
                  donemek=1
                 END IF

              END DO

              !************
              !Ending time.
              !************
              donemek=0
              TNMEK=NMEK !N ending times
              LENIBFACED=LENIBFACE(K1)+LENIBCELL(K1)
              DO
                 IF (donemek.EQ.1) EXIT
                 !Mean recession rate
                 SUMMEK=MEK(startMEK)*(MEKTIMES(startMEK))
                 IF (ABS(startMEK-TNMEK).GE.2) THEN
                  DO B=(startMEK+1),(TNMEK-1)
                   SUMMEK=SUMMEK+(MEK(B)*(MEKTIMES(B)-MEKTIMES(B-1)))
                  END DO
                 END IF
                 IF (TNMEK.EQ.1) THEN
                    MAXLEN=SUMMEK
                 ELSE
                    MAXLEN=SUMMEK+((MEKTIMES(TNMEK)-MEKTIMES(TNMEK-1))*MEK(TNMEK))
                 END IF
                 IF (MAXLEN.GT.LENIBFACED) THEN
                   IF(MEK(TNMEK).EQ.0) THEN
                    MEKTIMED(K1)=0
                   ELSE IF(TNMEK.EQ.1) THEN
                    MEKTIMED(K1)=(LENIBFACED/MEK(TNMEK))
                    MEKEND(K1)=0.
                   ELSE
                    MEKTIMED(K1)=((LENIBFACED-SUMMEK)/MEK(TNMEK))+MEKTIMES(TNMEK-1)
                    MEKEND(K1)=0.
                   END IF
                 ELSE
                  IF(MEK(TNMEK).EQ.0) THEN
                   MEKTIMED(K1)=0
                  ELSE
                   MEKTIMED(K1)=((MAXLEN-SUMMEK)/MEK(TNMEK))+MEKTIMES(TNMEK-1)
                   donemek=1
                   MEKEND(K1)=(((LENIBFACED-SUMMEK)/MEK(TNMEK))+MEKTIMES(TNMEK-1))-MEKTIMED(K1)
                  END IF
                 END IF

                 !Check for current recession
                 IF (MEKTIMED(K1).LT.MEKTIMES(TNMEK-1)) THEN
                  TNMEK=TNMEK-1
                 ELSE
                  donemek=1
                 END IF
              END DO
         END IF !End decomposing cell volumes

       END DO
      END DO
     END DO


     END SUBROUTINE !End MECH_EROSION



 !Name: DIRECTIONVECTORS
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Calculates the direction vectors for the decompoosing material.
     SUBROUTINE directionVectors
     USE GlobaleVariable
     implicit none

     DOUBLE PRECISION                    :: LENIFACE,TLENIFACE,IDX,IDY
     INTEGER                             :: K1,I,J,K,IMESH


     DO IMESH=1,NMESH
      DO I=1,NI(IMESH)-1
       DO J=1,NJ(IMESH)-1
          K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
          !For decomposing cell volumes
         IF(IFACEBULK(K1).EQ.1) THEN
           IDX=XCP(IFACE(K))-XCP(K1)
           IDY=YCP(IFACE(K))-YCP(K1)
           LENIFACE=SQRT((IDX**2)+(IDY**2))+1
           DO K=1,NIFACE
            IDX=XCP(IFACE(K))-XCP(K1)
            IDY=YCP(IFACE(K))-YCP(K1)
            TLENIFACE=SQRT((IDX**2)+(IDY**2))
            IF(TLENIFACE.LT.LENIFACE) THEN
              VX(K1)=IDX
              VY(K1)=IDY
              LENIFACE=TLENIFACE
            END IF
           END DO
          ELSE IF(IFACEBULK(K1).GE.2 .AND. ABS(IFACEVALUE-0.02).LT.0.001) THEN
            IDX=IBFACEX(1)-XCP(K1)
            IDY=IBFACEY(1)-YCP(K1)
            LENIFACE=SQRT((IDX**2)+(IDY**2))+1
            DO K=1,NBFACE
             IDX=IBFACEX(K)-XCP(K1)
             IDY=IBFACEY(K)-YCP(K1)
             TLENIFACE=SQRT((IDX**2)+(IDY**2))
             IF(TLENIFACE.LT.LENIFACE) THEN
              VX(K1)=IDX
              VY(K1)=IDY
              LENIFACE=TLENIFACE
             END IF
            END DO
          END IF !End decomposing cell volumes

       END DO
      END DO
     END DO

     END SUBROUTINE !End directionVectors

 !Name: Continuity
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Solves the continuity equation using vectors.
     SUBROUTINE CONTINUITY
     USE GlobaleVariable
     implicit none

     INTEGER                             :: IMESH,K1,K2,K3,I,J,done,W1,E1,S1,N1
     DOUBLE PRECISION                    :: mOUT,Angle,iy,ix
     INTEGER,DIMENSION(4)                :: aDIR
     DOUBLE PRECISION, DIMENSION(35000)  :: lamdaX,lamdaY,mOLD
     INTEGER,DIMENSION(35000,4)          :: bDIR

    done=0
    MI=MI*0
    MJ=MJ*0
    CALL directionVectors

    DO IMESH=1,NMESH
     DO I=1,NI(IMESH)-1
      DO J=1,NJ(IMESH)-1
       !Coordinates in 1D-vector
       K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
       K2=K1+1
       !For decomposing cell volumes
       IF(IFACEBULK(K1)>0) THEN
        !Gas direction
        ix=XM(K2)-XM(K1)
        iy=YM(K2)-YM(K1)
        Angle=ATAN2(VY(K1),VX(K1))-ATAN2(iy,ix)
        IF (Angle.LT.0) THEN
           Angle=Angle+(2*PI)
        END IF

        IF (Angle.LT.PI) THEN
           IF (Angle.LT.(PI/2)) THEN
              IF(Angle.EQ.0) THEN
              aDIR=(/0,1,1,1/)
              ELSE
              aDIR=(/0,1,0,1/)
              END IF
              lamdaY(K1)=2*Angle/PI
              lamdaX(K1)=1-lamdaY(K1)
           ELSE
              IF(ABS(Angle-(PI/2)).LT.0.001) THEN
              aDIR=(/1,1,0,1/)
              ELSE
              aDIR=(/1,0,0,1/)
              END IF
              lamdaX(K1)=2*((PI/2)-Angle)/PI
              lamdaY(K1)=1+lamdaX(K1)
           END IF
        ELSE
           IF (Angle.LT.(3*PI/2)) THEN
              IF (ABS(Angle-PI).LT.0.001) THEN
              aDIR=(/1,0,1,1/)
              ELSE
              aDIR=(/1,0,1,0/)
              END IF
              lamdaY(K1)=2*(PI-Angle)/PI
              lamdaX(K1)=(-1)-lamdaY(K1)
           ELSE
              IF (ABS(Angle-(3*PI/2)).LT.0.001) THEN
              aDIR=(/1,1,1,0/)
              ELSE IF (ABS(Angle-(2*PI)).LT.0.001) THEN
              aDIR=(/0,1,1,1/)
              ELSE
              aDIR=(/0,1,1,0/)
              END IF
              lamdaX(K1)=2*(Angle-(3*PI/2))/PI
              lamdaY(K1)=lamdaX(K1)-1
           END IF
        END IF
        bDIR(K1,:)=aDIR(:)
       END IF !End decomposing cell volumes
      END DO !End J
     END DO !End I
    END DO !End IMESH

      !Iteration routine
      DO

       IF(done.EQ.1) EXIT
       done=1

       DO IMESH=1,NMESH
         DO I=1,NI(IMESH)-1
           DO J=1,NJ(IMESH)-1
             !Coordinates in 1D-vector
             K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
             !For decomposing cell volumes
             IF(IFACEBULK(K1)>0) THEN
              K2=K1+1
              K3=K1+NI(IMESH)

              mOUT=((-1)*MPYR(K1))-(bDIR(K1,1)*MI(K2))+(bDIR(K1,2)*MI(K1))- &
                   (bDIR(K1,3)*MJ(K3))+(bDIR(K1,4)*MJ(K1))

              IF (I.EQ.1) THEN
                 W1=boundWU(1,J,IMESH)
                 IF (W1.EQ.1) THEN
                   MJ(boundWU(2,J,IMESH))=(bDIR(K1,2)*MI(K1))+(bDIR(K1,1)*lamdaX(K1)*mOUT) !WEST
                 ELSEIF (W1.EQ.2) THEN
                   MI(boundWU(2,J,IMESH))=(bDIR(K1,2)*MI(K1))+(bDIR(K1,1)*lamdaX(K1)*mOUT) !WEST
                 END IF
              ELSE IF (I.EQ.(NI(IMESH)-1)) THEN
                 E1=boundEU(1,J,IMESH)
                 IF (E1.EQ.1) THEN
                   MJ(boundEU(2,J,IMESH))=(bDIR(K1,1)*MI(K2))+(bDIR(K1,2)*lamdaX(K1)*mOUT) !East
                 ELSEIF (E1.EQ.2) THEN
                   MI(boundEU(2,J,IMESH))=(bDIR(K1,1)*MI(K2))+(bDIR(K1,2)*lamdaX(K1)*mOUT) !East
                 END IF
              END IF

              IF (J.EQ.1) THEN
                 S1=boundSU(1,I,IMESH)
                 IF (S1.EQ.1) THEN
                   MJ(boundSU(2,I,IMESH))=(bDIR(K1,4)*MJ(K1))+(bDIR(K1,3)*lamdaY(K1)*mOUT) !SOUTH
                 ELSEIF (S1.EQ.2) THEN
                   MI(boundSU(2,I,IMESH))=(bDIR(K1,4)*MJ(K1))+(bDIR(K1,3)*lamdaY(K1)*mOUT) !SOUTH
                 END IF
              ELSE IF (J.EQ.(NJ(IMESH)-1)) THEN
                 N1=boundNU(1,I,IMESH)
                 IF (N1.EQ.1) THEN
                   MJ(boundNU(2,I,IMESH))=(bDIR(K1,3)*MJ(K3))+(bDIR(K1,4)*lamdaY(K1)*mOUT) !NORTH
                 ELSEIF (N1.EQ.2) THEN
                   MI(boundNU(2,I,IMESH))=(bDIR(K1,3)*MJ(K3))+(bDIR(K1,4)*lamdaY(K1)*mOUT) !NORTH
                 END IF
              END IF

              MI(K1)=(bDIR(K1,2)*MI(K1))+(bDIR(K1,1)*lamdaX(K1)*mOUT) !WEST
              MI(K2)=(bDIR(K1,1)*MI(K2))+(bDIR(K1,2)*lamdaX(K1)*mOUT) !EAST
              MJ(K1)=(bDIR(K1,4)*MJ(K1))+(bDIR(K1,3)*lamdaY(K1)*mOUT) !SOUTH
              MJ(K3)=(bDIR(K1,3)*MJ(K3))+(bDIR(K1,4)*lamdaY(K1)*mOUT) !NORTH

              !Check for convergence
              IF(ABS(mOLD(K1)-mOUT).GT.1E-12) THEN
                 done=0
              END IF
              mOLD(K1)=mOUT
             END IF !End decomposing cell volumes
           END DO !End J
         END DO !End I
       END DO !End MESH

      END DO !End iterasjon

     END SUBROUTINE !End Continuity


 !Name: INIT_PYROLYSIS
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Solves the continuity equation using vectors.
     SUBROUTINE INIT_PYROLYSIS
     USE GlobaleVariable
     implicit none

     INTEGER                             :: K1,K2,K3,K4,II,JJ,IIMESH,PYRMAT,REAC,switch
     DOUBLE PRECISION                    :: xp1,yp1,xp2,yp2,xp3,yp3,xp4,yp4,a1to3,b1to3, &
                                            a4to2,b4to2,tempx1,tempx2
       !Decision variable for the interface
       IF(IFACEVALUE.EQ.0) THEN
         IFACEVALUE=0.02
       END IF

       !Initializing parameters
       IF (Pyrini.EQ.1) THEN
            Pyrini=0
            RHORTOT=RHORTOT*0
            RHOOTOT=RHOOTOT*0
            VX=VX*0
            VY=VY*0
            VMX=VMX*0
            VMY=VMY*0
            MEKEND=MEKEND*0
            precisionP=1.0E2
         DO IIMESH=1,NMESH
           DO JJ=1,NJ(IIMESH)-1
             DO II=1,NI(IIMESH)-1
              K1=II+NI(IIMESH)*(JJ-1)+NMP(IIMESH)
              !For decomposing cell volumes
              IF(IFACEBULK(K1)>0) THEN     
               PYRMAT=MAT(K1)
               ANTPYR(K1)=AM_ANTPYR(PYRMAT)
               DO REAC=1,ANTPYR(K1)
                 VOLFRAC(REAC,K1)=AM_VOLFRAC(REAC,PYRMAT)
                 RHO(REAC,K1)=AM_RHOO(REAC,PYRMAT)*VOLFRAC(REAC,K1)
                 RHOO(REAC,K1)=AM_RHOO(REAC,PYRMAT)*VOLFRAC(REAC,K1)
                 RHOR(REAC,K1)=AM_RHOR(REAC,PYRMAT)*VOLFRAC(REAC,K1)
                 APYR(REAC,K1)=AM_APYR(REAC,PYRMAT)
                 EPYR(REAC,K1)=AM_EPYR(REAC,PYRMAT)
                 NPYR(REAC,K1)=AM_NPYR(REAC,PYRMAT)
                 TREAC(REAC,K1)=AM_TREAC(REAC,PYRMAT)
                 RHOOTOT(K1)=RHOOTOT(K1)+RHOO(REAC,K1)
                 RHORTOT(K1)=RHORTOT(K1)+RHOR(REAC,K1)
               END DO
               RHOFRAC(K1)=1.
               RO(K1)=RHOOTOT(K1)
               MEKSTART(K1)=0
               MEKTIME(K1)=1.0E15
               MEKTIMED(K1)=1.0E15

              END IF
             END DO
           END DO
         END DO
       END IF

       !Initializing parameters
       NBFACE=0
       IBFACEX=IBFACEX*0
       IBFACEY=IBFACEY*0
       DO IIMESH=1,NMESH
         DO JJ=1,NJ(IIMESH)-1
           DO II=1,NI(IIMESH)-1
             !Defining centerpoints in the cell volume
             K1=II+NI(IIMESH)*(JJ-1)+NMP(IIMESH)
             !For decomposing cell volumes
             IF(IFACEBULK(K1)>0) THEN
              K2=K1+1
              K3=K1+NI(IIMESH)
              K4=K3+1

              !Edge coordinated xp=x-point,yp=y-point, 1=south, 2=east, 3=north and 4=west
              xp1=XM(K1)+((XM(K2)-XM(K1))/2)
              yp1=YM(K1)+((YM(K2)-YM(K1))/2)
              xp2=XM(K2)+((XM(K4)-XM(K2))/2)
              yp2=YM(K2)+((YM(K4)-YM(K2))/2)
              xp3=XM(K4)+((XM(K3)-XM(K4))/2)
              yp3=YM(K4)+((YM(K3)-YM(K4))/2)
              xp4=XM(K3)+((XM(K1)-XM(K3))/2)
              yp4=YM(K3)+((YM(K1)-YM(K3))/2)
              !Line 1->3 and 4->2 makes an intersection (y=ax+b)
              switch=1
              tempx1=(xp3-xp1)
              IF(ABS(tempx1).GT.0.0) THEN
                a1to3=(yp3-yp1)/tempx1
                b1to3=yp3-(a1to3*xp3)
              ELSE
                switch=0
                XCP(K1)=xp3
              END IF
                tempx2=(xp2-xp4)
              IF(ABS(tempx2).GT.0.0) THEN
                a4to2=(yp2-yp4)/tempx2
                b4to2=yp4-(a4to2*xp4)
              ELSE
                switch=0
                XCP(K1)=xp2
              END IF


              !Center point in cell volume k1: XCP(K1),YCP(K1)
              IF (switch.EQ.1) THEN
               IF(ABS(a1to3).GT.0.0) THEN
                XCP(K1)=(b4to2-b1to3)/(a1to3-a4to2)
                YCP(K1)=(a1to3*XCP(K1))+b1to3
               ELSE
                XCP(K1)=(b4to2-b1to3)/(a1to3-a4to2)
                YCP(K1)=(a4to2*XCP(K1))+b4to2
               END IF
              ELSE
               IF(ABS(tempx1).GT.0.0) THEN
                  YCP(K1)=b1to3+(a1to3*XCP(K1))
                ELSE
                  YCP(K1)=b4to2+(a4to2*XCP(K1))
                END IF
              END IF

              IF(II.EQ.1) THEN
                 IF(boundW(2,JJ,IIMESH).GT.0) THEN
                   WRITE(6,*) 'west'
                   IFACEBULK(K1)=3
                   VX(K1)=xp4-XCP(K1)
                   VY(K1)=yp4-YCP(K1)
                   NBFACE=NBFACE+1
                   IBFACEX(NBFACE)=xp4
                   IBFACEY(NBFACE)=yp4
                 END IF
              ELSEIF(II.EQ.(NI(IIMESH)-1)) THEN
                 IF (boundE(2,JJ,IIMESH).GT.0) THEN
                   WRITE(6,*) 'east'
                   IFACEBULK(K1)=3
                   VX(K1)=xp2-XCP(K1)
                   VY(K1)=yp2-YCP(K1)
                   NBFACE=NBFACE+1
                   IBFACEX(NBFACE)=xp2
                   IBFACEY(NBFACE)=yp2
                   END IF
              END IF

              IF (JJ.EQ.1) THEN
                 IF (boundS(2,II,IIMESH).GT.0) THEN
                   WRITE(6,*) 'south'
                   IFACEBULK(K1)=3
                   VX(K1)=xp1-XCP(K1)
                   VY(K1)=yp1-YCP(K1)
                   NBFACE=NBFACE+1
                   IBFACEX(NBFACE)=xp1
                   IBFACEY(NBFACE)=yp1
                 END IF
                 IF(ABS(boundS(2,II,IIMESH)-1).LT.0.0001) THEN
                   precisionP=1.0E14
                 ELSE
                   precisionP=1.0E2
                 END IF
              ELSEIF (JJ.EQ.(NJ(IIMESH)-1)) THEN
                 IF (boundN(2,II,IIMESH).GT.0) THEN
                   WRITE(6,*) 'north'
                   IFACEBULK(K1)=3
                   VX(K1)=xp3-XCP(K1)
                   VY(K1)=yp3-YCP(K1)
                   NBFACE=NBFACE+1
                   IBFACEX(NBFACE)=xp3
                   IBFACEY(NBFACE)=yp3
                 END IF
              END IF

             END IF !End decomposing cell volumes
           END DO !End J
         END DO !End I
       END DO !End Mesh

       !If recession rates are specified
       IF (M_EROSION.EQ.1) THEN
        CALL MECH_EROSION
        M_EROSION=0
       END IF

     END SUBROUTINE !End INIT_PYROLYSIS


 !Name: PYROLYSIS
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Solves the internal decomposition reactions and adjust material properties.
     SUBROUTINE PYROLYSIS
     USE GlobaleVariable
     implicit none

     DOUBLE PRECISION                    :: DALFA,RHOTEMP,RHORTEMP,RHODIFF,ALFADIFF,ALFATEMP,T,TMIN,TMAX,XSI,T1,T2,XFRAC, &
                                            MEKDTIME,MFRAC
     INTEGER                             :: NREAC,REAC,K1,K2,K3,K4,K5,I,J,IMESH,IIMAT,IT,N

     NIFACE=0
     IFACE=IFACE*0

     DO IMESH=1,NMESH
        DO I=1,NI(IMESH)-1
           DO J=1,NJ(IMESH)-1
            K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
            K3=K1+NI(IMESH)
            !For decomposing cell volumes
            IF(IFACEBULK(K1).GT.0) THEN
             !Check for starting time of recession (default=MEKTIME>TIME)
            IF (TIME.GT.MEKTIME(K1)) THEN
               IF (TIME.GE.MEKTIMED(K1)) THEN
                IF (MEKEND(K1).LE.0) THEN
                   C(K1)=0.01
                   TCI(K1)=1*precisionP
                   TCJ(K1)=1*precisionP
                   RO(K1)=0.1
                   MPYR(K1)=0.
                   RHOFRAC(K1)=0.
                   CPG(K1)=0.
                   DHPYR(K1)=0.
                END IF
               ELSE
                 !Calculates the recession rate of the cell volume
                 IF(MEKSTART(K1).EQ.0) THEN
                  MEKDTIME=(MEKTIMED(K1)+MEKEND(K1))-TIME
                  MEKRHOTOT(K1)=RO(K1)
                  MEKALFA(K1)=MEKRHOTOT(K1)/MEKDTIME
                  MEKSTART(K1)=1
                 END IF
                 RO(K1)=RO(K1)-(MEKALFA(K1)*DTIME)
                 MPYR(K1)=0.
                 MFRAC=RO(K1)/MEKRHOTOT(K1)
                 IF (MFRAC.LE.0.0) THEN
                   RO(K1)=0.1
                   MFRAC=0.
                 END IF

                 XFRAC=RHOFRAC(K1)

                 !Update material properties
                 T=TEMP(K1)
               	 IIMAT=MAT(K1)
               	 N=NINT(AM_DATA(IIMAT))
               	 TMIN=AM_TEMP(IIMAT,1)
               	 TMAX=AM_TEMP(IIMAT,N)
               	 IF (T.LE.TMIN) THEN
               	  T1=TMIN
               	  T2=TMIN
               	  TCI(K1)=((AM_TCI(IIMAT,1)*XFRAC)+(AM_TCIR(IIMAT,1)*(1-XFRAC))*MFRAC)+((1-MFRAC)*1.0*precisionP)
               	  TCJ(K1)=((AM_TCJ(IIMAT,1)*XFRAC)+(AM_TCJR(IIMAT,1)*(1-XFRAC))*MFRAC)+((1-MFRAC)*1.0*precisionP)
               	  C(K1)  =(((AM_CP(IIMAT,1)*XFRAC)+(AM_CPR(IIMAT,1)*(1-XFRAC)))*MFRAC)+((1-MFRAC)*(0.1E-1))
                  CPG(K1)=AM_CPG(IIMAT,1)
                  DHPYR(K1)=AM_DHPYR(IIMAT,1)
               	 ELSE IF (T.GE.TMAX) THEN
               	  T1=TMAX
               	  T2=TMAX
               	  TCI(K1)=((AM_TCI(IIMAT,N)*XFRAC)+(AM_TCIR(IIMAT,N)*(1-XFRAC))*MFRAC)+((1-MFRAC)*1.0*precisionP)
             	  TCJ(K1)=((AM_TCJ(IIMAT,N)*XFRAC)+(AM_TCJR(IIMAT,N)*(1-XFRAC))*MFRAC)+((1-MFRAC)*1.0*precisionP)
               	  C(K1)  =(((AM_CP(IIMAT,N)*XFRAC)+(AM_CPR(IIMAT,N)*(1-XFRAC)))*MFRAC)+((1-MFRAC)*(0.1E-1))
                  CPG(K1)=AM_CPG(IIMAT,N)
                  DHPYR(K1)=AM_DHPYR(IIMAT,N)
               	 ELSE
               	  DO IT=1,N-1
               	   T1=AM_TEMP(IIMAT,IT)
               	   T2=AM_TEMP(IIMAT,IT+1)
               	   XSI=(T-T1)/(T2-T1)
               	   IF(T2.GT.T)EXIT
             	  END DO
                  TCI(K1)=((((((1.-XSI)*AM_TCI(IIMAT,IT))+(XSI*AM_TCI(IIMAT,IT+1)))*XFRAC)+ &
                          ((((1.-XSI)*AM_TCIR(IIMAT,IT))+(XSI*AM_TCIR(IIMAT,IT+1)))*(1-XFRAC)))*MFRAC)+ &
                          ((1-MFRAC)*1.0*precisionP)
                  TCJ(K1)=((((((1.-XSI)*AM_TCJ(IIMAT,IT))+(XSI*AM_TCJ(IIMAT,IT+1)))*XFRAC)+ &
                          ((((1.-XSI)*AM_TCJR(IIMAT,IT))+(XSI*AM_TCJR(IIMAT,IT+1)))*(1-XFRAC)))*MFRAC)+ &
                          ((1-MFRAC)*1.0*precisionP)
             	  C(K1)  =(((((1.-XSI)*AM_CP(IIMAT,IT) +XSI*AM_CP(IIMAT,IT+1))*XFRAC)+ &
                           (((1.-XSI)*AM_CPR(IIMAT,IT)+XSI*AM_CPR(IIMAT,IT+1))*(1-XFRAC)))* &
                           MFRAC)+((1-MFRAC)*(0.1E-1))
                  CPG(K1)=((1.-XSI)*AM_CPG(IIMAT,IT)) +(XSI*AM_CPG(IIMAT,IT+1))
                  DHPYR(K1)=((1.-XSI)*AM_DHPYR(IIMAT,IT)) +(XSI*AM_DHPYR(IIMAT,IT+1))
             	 END IF
               END IF

             !End M_EROSION
             ELSE
               NREAC=ANTPYR(K1)
               !Calculates the pyrolysis reactions
               ALFATEMP=0.
               DO REAC=1,NREAC
                 RHORTEMP=RHOR(REAC,K1)
                 RHOTEMP=RHO(REAC,K1)
                 RHODIFF=RHOO(REAC,K1)-RHORTEMP
                 IF (TEMP(K1).GT.TREAC(REAC,K1)) THEN
                    DALFA=DTIME*RHODIFF*((((RHOTEMP-RHORTEMP))/RHODIFF)**NPYR(REAC,K1))* &
                       APYR(REAC,K1)*EXP(-EPYR(REAC,K1)/TEMP(K1))
                    IF (RHOTEMP.GT.RHORTEMP) THEN
                       ALFADIFF=RHOTEMP-DALFA
                       IF (ALFADIFF.GT.RHORTEMP) THEN
                          ALFATEMP=ALFATEMP+DALFA
                          RHO(REAC,K1)=ALFADIFF
                       ELSE
                          ALFATEMP=ALFATEMP+(RHOTEMP-RHORTEMP)
                          RHO(REAC,K1)=RHORTEMP
                       END IF
                    END IF
                 END IF
               END DO


                 !Update the density and pyrolysis gas rate
                 MPYR(K1)=((-ALFATEMP)*VOL(K1))/DTIME
                 RO(K1)=RO(K1)-ALFATEMP
                 IF (RO(K1).LE.0) THEN
                   RO(K1)=0.1
                 END IF

                 !Fraction parameter
                 XFRAC=(RO(K1)-RHORTOT(K1))/(RHOOTOT(K1)-RHORTOT(K1))
                 RHOFRAC(K1)=XFRAC

                 !Update material properties
                 T=TEMP(K1)
         	 IIMAT=MAT(K1)
         	 N=NINT(AM_DATA(IIMAT))
        	 TMIN=AM_TEMP(IIMAT,1)
        	 TMAX=AM_TEMP(IIMAT,N)
        	 IF (T.LE.TMIN) THEN
          	  T1=TMIN
          	  T2=TMIN
          	  TCI(K1)=(AM_TCI(IIMAT,1)*XFRAC)+(AM_TCIR(IIMAT,1)*(1-XFRAC))
          	  TCJ(K1)=(AM_TCJ(IIMAT,1)*XFRAC)+(AM_TCJR(IIMAT,1)*(1-XFRAC))
          	  C(K1)  =(AM_CP(IIMAT,1)*XFRAC)+(AM_CPR(IIMAT,1)*(1-XFRAC))
                  CPG(K1)=AM_CPG(IIMAT,1)
                  DHPYR(K1)=AM_DHPYR(IIMAT,1)
        	 ELSE IF (T.GE.TMAX) THEN
          	  T1=TMAX
          	  T2=TMAX
          	  TCI(K1)=(AM_TCI(IIMAT,N)*XFRAC)+(AM_TCIR(IIMAT,N)*(1-XFRAC))
          	  TCJ(K1)=(AM_TCJ(IIMAT,N)*XFRAC)+(AM_TCJR(IIMAT,N)*(1-XFRAC))
          	  C(K1)  =(AM_CP(IIMAT,N)*XFRAC)+(AM_CPR(IIMAT,N)*(1-XFRAC))
                  CPG(K1)=AM_CPG(IIMAT,N)
                  DHPYR(K1)=AM_DHPYR(IIMAT,N)
        	 ELSE
          	  DO IT=1,N-1
            	   T1=AM_TEMP(IIMAT,IT)
            	   T2=AM_TEMP(IIMAT,IT+1)
            	   XSI=(T-T1)/(T2-T1)
            	   IF(T2.GE.T)EXIT
          	  END DO
                  TCI(K1)=((((1.-XSI)*AM_TCI(IIMAT,IT))+(XSI*AM_TCI(IIMAT,IT+1)))*XFRAC)+ &
                          ((((1.-XSI)*AM_TCIR(IIMAT,IT))+(XSI*AM_TCIR(IIMAT,IT+1)))*(1-XFRAC))
                  TCJ(K1)=((((1.-XSI)*AM_TCJ(IIMAT,IT))+(XSI*AM_TCJ(IIMAT,IT+1)))*XFRAC)+ &
                          ((((1.-XSI)*AM_TCJR(IIMAT,IT))+(XSI*AM_TCJR(IIMAT,IT+1)))*(1-XFRAC))
          	  C(K1)  =(((1.-XSI)*AM_CP(IIMAT,IT) +XSI*AM_CP(IIMAT,IT+1))*XFRAC)+ &
                          (((1.-XSI)*AM_CPR(IIMAT,IT)+XSI*AM_CPR(IIMAT,IT+1))*(1-XFRAC))
                  CPG(K1)=AM_CPG(IIMAT,IT) !((1.-XSI)*AM_CPG(IIMAT,IT)) +(XSI*AM_CPG(IIMAT,IT+1))
                  DHPYR(K1)=((1.-XSI)*AM_DHPYR(IIMAT,IT)) +(XSI*AM_DHPYR(IIMAT,IT+1))
        	 END IF
             END IF !End material properties for decomposing cell volumes


             !Updates the identification parameter
             IF (RHOFRAC(K1).LT.IFACEVALUE) THEN
               IF(IFACEBULK(K1).LT.3) THEN
               IFACEBULK(K1)=2
               END IF
             END IF

             !For residue or "empty" cell volumes
             IF(IFACEBULK(K1).GE.2) THEN
                !Find the cell volumes on the interface between virgin/decomposing material and residue material
                !-> K2=east <-> K4=west <-> K3=north <-> K5=south <- of K1, check if id=1 is a neighbour
                IF (I.EQ.1) THEN
                   !West
                   K4=boundWU(5,J,IMESH)
                   K2=K1+1
                ELSE IF (I.EQ.(NI(IMESH)-1)) THEN
                   !East
                   K4=K1-1
                   K2=boundEU(5,J,IMESH)
                ELSE
                   !Internal
                   K4=K1-1
                   K2=K1+1
                END IF

                IF (J.EQ.1) THEN
                   !South
                   K5=boundSU(5,I,IMESH)
                   K3=K1+NI(IMESH)
                ELSE IF (J.EQ.(NJ(IMESH)-1)) THEN
                   !North
                   K5=K1-NI(IMESH)
                   K3=boundNU(5,I,IMESH)
                ELSE
                   K5=K1-NI(IMESH)
                   K3=K1+NI(IMESH)
                END IF

                IF(K2.GT.0) THEN
                  IF(RHOFRAC(K2).GT.IFACEVALUE) THEN
                    NIFACE=NIFACE+1
                    IFACE(NIFACE)=K1
                    K3=0
                    k4=0
                    k5=0
                  END IF
                END IF
                IF(K3.GT.0) THEN
                  IF(RHOFRAC(K3).GT.IFACEVALUE) THEN
                    NIFACE=NIFACE+1
                    IFACE(NIFACE)=K1
                    K4=0
                    K5=0
                  END IF
                END IF
                IF(K4.GT.0) THEN
                  IF(RHOFRAC(K4).GT.IFACEVALUE) THEN
                    NIFACE=NIFACE+1
                    IFACE(NIFACE)=K1
                    K5=0
                  END IF
                END IF
                IF(K5.GT.0) THEN
                  IF(RHOFRAC(K5).GT.IFACEVALUE) THEN
                    NIFACE=NIFACE+1
                    IFACE(NIFACE)=K1
                  END IF
                END IF

             END IF !End decomposing cell volumes



            ELSE  !Update properties of backup material

                T=TEMP(K1)
                IIMAT=MAT(K1)
                N=NINT(AM_DATA(IIMAT))
                TMIN=AM_TEMP(IIMAT,1)
                TMAX=AM_TEMP(IIMAT,N)
                IF (T.LE.TMIN) THEN
                  T1=TMIN
                  T2=TMIN
                  RO(K1) =AM_RO(IIMAT,1)
                  TCI(K1)=AM_TCI(IIMAT,1)
                  TCJ(K1)=AM_TCJ(IIMAT,1)
                  C(K1)  =AM_CP(IIMAT,1)
                ELSE IF (T.GE.TMAX) THEN
                  T1=TMAX
                  T2=TMAX
                  RO(K1) =AM_RO(IIMAT,N)
                  TCI(K1)=AM_TCI(IIMAT,N)
                  TCJ(K1)=AM_TCJ(IIMAT,N)
                  C(K1)  =AM_CP(IIMAT,N)
                ELSE
                  DO IT=1,N-1
                   T1=AM_TEMP(IIMAT,IT)
                   T2=AM_TEMP(IIMAT,IT+1)
                   XSI=(T-T1)/(T2-T1)
                   IF(T2.GT.T)EXIT
                  END DO
                  RO(K1) =(1.-XSI)*AM_RO(IIMAT,IT) +XSI*AM_RO(IIMAT,IT+1)
                  TCI(K1)=(1.-XSI)*AM_TCI(IIMAT,IT)+XSI*AM_TCI(IIMAT,IT+1)
                  TCJ(K1)=(1.-XSI)*AM_TCJ(IIMAT,IT)+XSI*AM_TCJ(IIMAT,IT+1)
                  C(K1)  =(1.-XSI)*AM_CP(IIMAT,IT) +XSI*AM_CP(IIMAT,IT+1)
                END IF

            END IF

           END DO !End J
        END DO !End I
     END DO !End MESH


     END SUBROUTINE !End pyrolysis


 !Name: UPDATE_IMPLICIT
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Updates the shadow cells, exchange information between grid blocks.
      SUBROUTINE UPDATE_IMPLICIT
      USE GlobaleVariable
      implicit none

      !Local variables
      INTEGER                             :: IMESH,J,I,E1,E2,W1,W2,N1,N2,S1,S2
      DOUBLE PRECISION                    :: REA,REB,RWA,RWB,RNA,RNB,RSA,RSB
      DOUBLE PRECISION                    :: GEA,GWA,GNA,GSA



      DO IMESH=1,NMESH
        DO J=1,NJ(IMESH)-1
           !East edge

           !Choice 1
           E1=boundEU(1,J,IMESH)

           IF (E1.EQ.0) THEN
              REA=0
              GEA=0
              !SourceTot=source * area
              boundE(5,J,IMESH)=boundE(2,J,IMESH)*boundE(1,J,IMESH)
           ELSE IF (E1.EQ.1) THEN
              !Temp and resistance J-direction
              REA=RJ(boundEU(2,J,IMESH))
              GEA=MJ(boundEU(2,J,IMESH))
              boundE(4,J,IMESH)=TEMP(boundEU(5,J,IMESH))
           ELSE IF (E1.EQ.2) THEN
              !Temp and resistance I-direction
              REA=RI(boundEU(2,J,IMESH))
              GEA=MI(boundEU(2,J,IMESH))
              boundE(4,J,IMESH)=TEMP(boundEU(5,J,IMESH))
           ELSE IF (E1.EQ.3) THEN
              GEA=0
              !Convective resistance
              REA=(1/boundE(2,J,IMESH))
           ELSE
              REA=0
              GEA=0
           END IF

           !Choice 2
           E2=boundEU(3,J,IMESH)

           IF (E2.EQ.1) THEN
              REB=RJ(boundEU(4,J,IMESH))
           ELSE IF (E2.EQ.2) THEN
              REB=RI(boundEU(4,J,IMESH))
           ELSE
              REB=0
           END IF

           REA=REA+REB
           !Calculates Area/Resistance
           IF (REA.NE.0) THEN
              boundE(3,J,IMESH)=(boundE(1,J,IMESH)/REA)+(CPG(boundEU(5,J,IMESH))*MAX(0.,(-GEA)))
           END IF
           !End East edge

           !West edge
           W1=boundWU(1,J,IMESH)
           IF (W1.EQ.0) THEN
              RWA=0
              GWA=0
              boundW(5,J,IMESH)=boundW(2,J,IMESH)*boundW(1,J,IMESH)
           ELSE IF (W1.EQ.1) THEN
              RWA=RJ(boundWU(2,J,IMESH))
              GWA=MJ(boundWU(2,J,IMESH))
              boundW(4,J,IMESH)=TEMP(boundWU(5,J,IMESH))
           ELSE IF (W1.EQ.2) THEN
              RWA=RI(boundWU(2,J,IMESH))
              GWA=MI(boundWU(2,J,IMESH))
              boundW(4,J,IMESH)=TEMP(boundWU(5,J,IMESH))
           ELSE IF (W1.EQ.3) THEN
              GWA=0
              RWA=1/boundW(2,J,IMESH)
           ELSE
              RWA=0
              GWA=0
           END IF

           W2=boundWU(3,J,IMESH)
           IF (W2.EQ.1) THEN
              RWB=RJ(boundWU(4,J,IMESH))
           ELSE IF (W2.EQ.2) THEN
              RWB=RI(boundWU(4,J,IMESH))
           ELSE
              RWB=0
           END IF

           RWA=RWA+RWB
           IF (RWA.NE.0) THEN
           boundW(3,J,IMESH)=(boundW(1,J,IMESH)/RWA)+(CPG(boundWU(5,J,IMESH))*MAX(0.,GWA))
           END IF
           !End West edge

        END DO !End West and East

        DO I=1,NI(IMESH)-1
           !North edge
           N1=boundNU(1,I,IMESH)
           IF (N1.EQ.0) THEN
              RNA=0
              GNA=0
              boundN(5,I,IMESH)=boundN(2,I,IMESH)*boundN(1,I,IMESH)
           ELSE IF (N1.EQ.1) THEN
              RNA=RJ(boundNU(2,I,IMESH))
              GNA=MJ(boundNU(2,I,IMESH))
              boundN(4,I,IMESH)=TEMP(boundNU(5,I,IMESH))
           ELSE IF (N1.EQ.2) THEN
              RNA=RI(boundNU(2,I,IMESH))
              GNA=MI(boundNU(2,I,IMESH))
              boundN(4,I,IMESH)=TEMP(boundNU(5,I,IMESH))
           ELSE IF (N1.EQ.3) THEN
              GNA=0
              RNA=1/boundN(2,I,IMESH)
           ELSE
              RNA=0
              GNA=0
           END IF

           N2=boundNU(3,I,IMESH)
           IF (N2.EQ.1) THEN
              RNB=RJ(boundNU(4,I,IMESH))
           ELSE IF (N2.EQ.2) THEN
              RNB=RI(boundNU(4,I,IMESH))
           ELSE
              RNB=0
           END IF

           RNA=RNA+RNB
           IF (RNA.NE.0) THEN
           boundN(3,I,IMESH)=(boundN(1,I,IMESH)/RNA)+(CPG(boundNU(5,I,IMESH))*MAX(0.,(-GNA)))
           END IF
           !End North edge

           !South edge
           S1=boundSU(1,I,IMESH)
           IF (S1.EQ.0) THEN
              RSA=0
              GSA=0
              boundS(5,I,IMESH)=boundS(2,I,IMESH)*boundS(1,I,IMESH)
           ELSE IF (S1.EQ.1) THEN
              RSA=RJ(boundSU(2,I,IMESH))
              GSA=MJ(boundSU(2,I,IMESH))
              boundS(4,I,IMESH)=TEMP(boundSU(5,I,IMESH))
           ELSE IF (S1.EQ.2) THEN
              RSA=RI(boundSU(2,I,IMESH))
              GSA=MI(boundSU(2,I,IMESH))
              boundS(4,I,IMESH)=TEMP(boundSU(5,I,IMESH))
           ELSE IF (S1.EQ.3) THEN
              GSA=0
              RSA=1/boundS(2,I,IMESH)
           ELSE
              RSA=0
              GSA=0
           END IF

           S2=boundSU(3,I,IMESH)
           IF (S2.EQ.1) THEN
              RSB=RJ(boundSU(4,I,IMESH))
           ELSE IF (S2.EQ.2) THEN
              RSB=RI(boundSU(4,I,IMESH))
           ELSE
              RSB=0
           END IF

           RSA=RSA+RSB
           IF (RSA.NE.0) THEN
           boundS(3,I,IMESH)=(boundS(1,I,IMESH)/RSA)+(CPG(boundSU(5,I,IMESH))*MAX(0.,GSA))
           END IF
           !End South edge
        END DO !End North and South

      END DO !End imesh

      END SUBROUTINE !End UPDATE_IMPLICIT



 !Name: BORDERS_IMPLICIT
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Initializing boundary conditions.
      SUBROUTINE BORDERS_IMPLICIT

      USE GlobaleVariable
      implicit none

      !Local variables
      INTEGER          :: ID,JD,IC,JC,IRS,JRS,IM,I0,J0,IDR,NP,K0,   &
                          K0I,K0J,KD,K1,KRSI,KRSJ,IBND,IPP
      DOUBLE PRECISION :: T,RADIUS,RE,ST
      DIMENSION ID(4),JD(4),IC(4),JC(4),IRS(4),JRS(4)
      INTEGER :: valg,step,pos

      DATA ID / 1, 0,-1, 0/ 
      DATA JD / 0, 1, 0,-1/
      DATA IC / 0,-1,-1, 0/  
      DATA JC / 0, 0,-1,-1/
      DATA IRS/ 1, 0, 1, 0/
      DATA JRS/ 0, 1, 0, 1/

      DO IBND=1,NBND
        IM =IMBND(IBND) !Block
        I0 =I0BND(IBND) !Start I
        J0 =J0BND(IBND) !Start J
        IDR=IDBND(IBND) !direction
        NP =NPBND(IBND) !Number of nodes in the direction

        !Pointer information for the cell volumes along the edge
        K0 =I0        +NI(IM)*(J0        -1)+NMP(IM)
        K0I=I0        +NI(IM)*(J0+JC(IDR)-1)+NMP(IM)
        K0J=I0+IC(IDR)+NI(IM)*(J0        -1)+NMP(IM)
        KD= ID(IDR)+NI(IM)* JD(IDR)

        !Decides if RI or RJ is used in the thermal resistance
        valg=JRS(IDR)+1

        !I-direction(Startposition=I0, step=ID(IDR))
        IF (IRS(IDR).EQ.1) THEN
          !North
          IF (J0.GT.(NJ(IM)/2)) THEN
               DO IPP=1,NP-1
                 K1  =K0 +KD*(IPP-1)
                 KRSI=K0I+KD*(IPP-1)
                 KRSJ=K0J+KD*(IPP-1)

                 !Describe the movement in the edge vector
                 step=(IPP)*ID(IDR)
                 pos=I0+step

                IF(ITBND(IBND).EQ.1 .OR. ITBND(IBND).EQ.5)THEN
                  IF(ITBND(IBND).EQ.5)THEN
                     T=(TIME-TSTART)/(TSTOP-TSTART)
                     !Create pointers and save information(area,HC ect.) in vectors
                     boundNU(1,pos,IM)=3
                     boundNU(3,pos,IM)=valg
                     boundNU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                     boundN(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundN(2,pos,IM)=HCBND(IBND)+T*DTHCBND(IBND)
                     boundN(4,pos,IM)=TUBND(IBND)+T*DTTUBND(IBND)
                  ELSE
                     boundNU(1,pos,IM)=3
                     boundNU(3,pos,IM)=valg
                     boundNU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                     boundN(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundN(2,pos,IM)=HCBND(IBND)
                     boundN(4,pos,IM)=TUBND(IBND)
                  ENDIF

                ENDIF

                IF(ITBND(IBND).EQ.2)THEN
                  boundN(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundN(2,pos,IM)=QBND(IBND)
                ENDIF

                IF(ITBND(IBND).EQ.3)THEN     !internal heat transfer
                  RADIUS=YM(K1)
                  RE=UBND(IBND,IPP)*RADIUS/VISCBND(IBND,IPP)
                  ST=0.0791/RE**0.25*0.5/                                         &
                  (1.+1.99*RE**(-0.125)*(PRBND(IBND,IPP)-1))

                  boundNU(1,pos,IM)=3
                  boundNU(3,pos,IM)=valg
                  boundNU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundN(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundN(2,pos,IM)=ROBND(IBND,IPP)*UBND(IBND,IPP)*CPBND(IBND,IPP)*ST
                  boundN(4,pos,IM)=TUBND(IBND)
                ENDIF
                IF(ITBND(IBND).EQ.4.OR.ITBND(IBND).EQ.6)THEN
                  boundNU(1,pos,IM)=3
                  boundNU(3,pos,IM)=valg
                  boundNU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundN(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundN(2,pos,IM)=HCEBND(IBND,IPP)
                  boundN(4,pos,IM)=TRBND(IBND,IPP)
                ENDIF

                IF(IRADBND(IBND).EQ.1)THEN   !add radiation heat transfer
                  boundN(6,pos,IM)=(TRADBND(IBND)**4)
                  boundN(7,pos,IM)=EMSBND(IBND)
                ENDIF
                IF(ITBND(IBND).EQ.7)THEN
                  boundNU(1,pos,IM)=4
                  boundNU(3,pos,IM)=valg
                  boundNU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundN(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundN(2,pos,IM)=1 !because of the pyrolysis, it has no functionality.
                  boundN(4,pos,IM)=TUBND(IBND)
                ENDIF

               END DO !End North


          ELSE !South
               DO IPP=1,NP-1
                 K1  =K0 +KD*(IPP-1)
                 KRSI=K0I+KD*(IPP-1)
                 KRSJ=K0J+KD*(IPP-1)

                 !Describe the movement in the edge vector
                 step=(IPP-1)*ID(IDR)
                 pos=I0+step


                IF(ITBND(IBND).EQ.1 .OR. ITBND(IBND).EQ.5)THEN
                  IF(ITBND(IBND).EQ.5)THEN
                     T=(TIME-TSTART)/(TSTOP-TSTART)
                     !Create pointers and save information(area,HC ect.) in vectors
                     boundSU(1,pos,IM)=3
                     boundSU(3,pos,IM)=valg
                     boundSU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                     boundS(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundS(2,pos,IM)=HCBND(IBND)+T*DTHCBND(IBND)
                     boundS(4,pos,IM)=TUBND(IBND)+T*DTTUBND(IBND)
                  ELSE
                     boundSU(1,pos,IM)=3
                     boundSU(3,pos,IM)=valg
                     boundSU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                     boundS(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundS(2,pos,IM)=HCBND(IBND)
                     boundS(4,pos,IM)=TUBND(IBND)
                  ENDIF

                ENDIF

                IF(ITBND(IBND).EQ.2)THEN
                  boundS(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundS(2,pos,IM)=QBND(IBND)
                ENDIF

                IF(ITBND(IBND).EQ.3)THEN     !internal heat transfer
                  RADIUS=YM(K1)
                  RE=UBND(IBND,IPP)*RADIUS/VISCBND(IBND,IPP)
                  ST=0.0791/RE**0.25*0.5/                                         &
                  (1.+1.99*RE**(-0.125)*(PRBND(IBND,IPP)-1))

                  boundSU(1,pos,IM)=3
                  boundSU(3,pos,IM)=valg
                  boundSU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundS(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundS(2,pos,IM)=ROBND(IBND,IPP)*UBND(IBND,IPP)*CPBND(IBND,IPP)*ST
                  boundS(4,pos,IM)=TUBND(IBND)
                ENDIF
                IF(ITBND(IBND).EQ.4.OR.ITBND(IBND).EQ.6)THEN
                  boundSU(1,pos,IM)=3
                  boundSU(3,pos,IM)=valg
                  boundSU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundS(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundS(2,pos,IM)=HCEBND(IBND,IPP)
                  boundS(4,pos,IM)=TRBND(IBND,IPP)
                ENDIF

                IF(IRADBND(IBND).EQ.1)THEN   !add radiation heat transfer
                  boundS(6,pos,IM)=(TRADBND(IBND)**4)
                  boundS(7,pos,IM)=EMSBND(IBND)
                ENDIF

                IF(ITBND(IBND).EQ.7)THEN
                  boundSU(1,pos,IM)=4
                  boundSU(3,pos,IM)=valg
                  boundSU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundS(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundS(2,pos,IM)=1 !because of the pyrolysis, it has no functionality.
                  boundS(4,pos,IM)=TUBND(IBND)
                ENDIF

               END DO !End South

          END IF !End North and South

        ELSE !J-Direction (Startposition=J0, step=JD(IDR))

          !East
          IF (I0.GT.(NI(IM)/2)) THEN
               DO IPP=1,NP-1
                 K1  =K0 +KD*(IPP-1)
                 KRSI=K0I+KD*(IPP-1)
                 KRSJ=K0J+KD*(IPP-1)

                 !Describe the movement in the edge vector
                 step=(IPP-1)*JD(IDR)
                 pos=J0+step


                IF(ITBND(IBND).EQ.1 .OR. ITBND(IBND).EQ.5)THEN
                  IF(ITBND(IBND).EQ.5)THEN
                     T=(TIME-TSTART)/(TSTOP-TSTART)
                     !Create pointers and save information(area,HC ect.) in vectors
                     boundEU(1,pos,IM)=3
                     boundEU(3,pos,IM)=valg
                     boundEU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                     boundE(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundE(2,pos,IM)=HCBND(IBND)+T*DTHCBND(IBND)
                     boundE(4,pos,IM)=TUBND(IBND)+T*DTTUBND(IBND)
                  ELSE
                     boundEU(1,pos,IM)=3
                     boundEU(3,pos,IM)=valg
                     boundEU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                     boundE(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundE(2,pos,IM)=HCBND(IBND)
                     boundE(4,pos,IM)=TUBND(IBND)
                  ENDIF

                ENDIF

                IF(ITBND(IBND).EQ.2)THEN
                     boundE(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundE(2,pos,IM)=QBND(IBND)
                ENDIF

                IF(ITBND(IBND).EQ.3)THEN     !internal heat transfer
                  RADIUS=YM(K1)
                  RE=UBND(IBND,IPP)*RADIUS/VISCBND(IBND,IPP)
                  ST=0.0791/RE**0.25*0.5/                                         &
                  (1.+1.99*RE**(-0.125)*(PRBND(IBND,IPP)-1))

                  boundEU(1,pos,IM)=3
                  boundEU(3,pos,IM)=valg
                  boundEU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundE(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundE(2,pos,IM)=ROBND(IBND,IPP)*UBND(IBND,IPP)*CPBND(IBND,IPP)*ST
                  boundE(4,pos,IM)=TUBND(IBND)
                ENDIF
                IF(ITBND(IBND).EQ.4.OR.ITBND(IBND).EQ.6)THEN
                  boundEU(1,pos,IM)=3
                  boundEU(3,pos,IM)=valg
                  boundEU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundE(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundE(2,pos,IM)=HCEBND(IBND,IPP)
                  boundE(4,pos,IM)=TRBND(IBND,IPP)
                ENDIF


                IF(IRADBND(IBND).EQ.1)THEN   !add radiation heat transfer
                  boundE(6,pos,IM)=(TRADBND(IBND)**4)
                  boundE(7,pos,IM)=EMSBND(IBND)
                ENDIF

                IF(ITBND(IBND).EQ.7)THEN
                  boundEU(1,pos,IM)=4
                  boundEU(3,pos,IM)=valg
                  boundEU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundE(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundE(2,pos,IM)=1 !because of the pyrolysis, it has no functionality.
                  boundE(4,pos,IM)=TUBND(IBND)
                ENDIF

               END DO !End East


          ELSE !West
               DO IPP=1,NP-1
                 K1  =K0 +KD*(IPP-1)
                 KRSI=K0I+KD*(IPP-1)
                 KRSJ=K0J+KD*(IPP-1)

                 !Describe the movement in the edge vector
                 step=IPP*JD(IDR)
                 pos=J0+step


                IF(ITBND(IBND).EQ.1 .OR. ITBND(IBND).EQ.5)THEN
                  IF(ITBND(IBND).EQ.5)THEN
                     T=(TIME-TSTART)/(TSTOP-TSTART)
                     !Create pointers and save information(area,HC ect.) in vectors
                     boundWU(1,pos,IM)=3
                     boundWU(3,pos,IM)=valg
                     boundWU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                     boundW(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundW(2,pos,IM)=HCBND(IBND)+T*DTHCBND(IBND)
                     boundW(4,pos,IM)=TUBND(IBND)+T*DTTUBND(IBND)
                  ELSE
                     boundWU(1,pos,IM)=3
                     boundWU(3,pos,IM)=valg
                     boundWU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                     boundW(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                     boundW(2,pos,IM)=HCBND(IBND)
                     boundW(4,pos,IM)=TUBND(IBND)
                  ENDIF

                ENDIF

                IF(ITBND(IBND).EQ.2)THEN
                  boundW(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundW(2,pos,IM)=QBND(IBND)
                ENDIF

                IF(ITBND(IBND).EQ.3)THEN     !internal heat transfer
                  RADIUS=YM(K1)
                  RE=UBND(IBND,IPP)*RADIUS/VISCBND(IBND,IPP)
                  ST=0.0791/RE**0.25*0.5/                                         &
                  (1.+1.99*RE**(-0.125)*(PRBND(IBND,IPP)-1))

                  boundWU(1,pos,IM)=3
                  boundWU(3,pos,IM)=valg
                  boundWU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundW(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundW(2,pos,IM)=ROBND(IBND,IPP)*UBND(IBND,IPP)*CPBND(IBND,IPP)*ST
                  boundW(4,pos,IM)=TUBND(IBND)
                ENDIF
                IF(ITBND(IBND).EQ.4.OR.ITBND(IBND).EQ.6)THEN
                  boundWU(1,pos,IM)=3
                  boundWU(3,pos,IM)=valg
                  boundWU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundW(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundW(2,pos,IM)=HCEBND(IBND,IPP)
                  boundW(4,pos,IM)=TRBND(IBND,IPP)
                ENDIF

                IF(IRADBND(IBND).EQ.1)THEN   !add radiation heat transfer
                  boundW(6,pos,IM)=(TRADBND(IBND)**4)
                  boundW(7,pos,IM)=EMSBND(IBND)
                ENDIF

                IF(ITBND(IBND).EQ.7)THEN
                  boundWU(1,pos,IM)=4
                  boundWU(3,pos,IM)=valg
                  boundWU(4,pos,IM)=KRSJ*IRS(IDR)+KRSI*JRS(IDR)
                  boundW(1,pos,IM)=AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)
                  boundW(2,pos,IM)=1 !because of the pyrolysis, it has no functionality.
                  boundW(4,pos,IM)=TUBND(IBND)
                ENDIF

               END DO !End West

          END IF !End East and West


        END IF !End directions


      END DO !End Boundary condition

  100 FORMAT(2I4,6F10.3)

      END SUBROUTINE !BORDERS_IMPLICIT




!Name: INIT_IMPLICIT
 !Author: Jrn Riise
 !Date: 30-06-2008
 !Description: Initializing pointer information for the interfaces and boundaries
      SUBROUTINE INIT_IMPLICIT
      USE GlobaleVariable
      implicit none

      !Local variables
      INTEGER          :: IIF,IMA,I0A,J0A,&
                          IDA,NPA,IMB,I0B,J0B,IDB,K0A,K0B,K0IA,K0JA,    &
                          K0IB,K0JB,KDA,KDB,KCA,KCB,KRSIA,KRSJA,KRSIB,  &
                          KRSJB,IPP,valgA,valgB,pos,step,stepS
      INTEGER, DIMENSION(4) :: ID,JD,ICA,JCA,ICB,JCB,IRS,JRS 


      DATA ID/ 1, 0,-1, 0/
      DATA JD/ 0, 1, 0,-1/
      DATA ICA/ 0,-1,-1, 0/
      DATA JCA/ 0, 0,-1,-1/
      DATA ICB/ 0, 0,-1,-1/
      DATA JCB/-1, 0, 0,-1/
      DATA IRS/ 1, 0, 1, 0/
      DATA JRS/ 0, 1, 0, 1/

      !Initializing shadow cells: Flux=0 -> insulated
      boundN=boundN*0
      boundS=boundS*0
      boundW=boundW*0
      boundE=boundE*0
      boundNU=boundNU*0
      boundSU=boundSU*0
      boundWU=boundWU*0
      boundEU=boundEU*0

      !Bestemme interfasegrenser

      DO 1 IIF=1,NIF
        IMA=IMAIF(IIF) !Block A
        I0A=I0AIF(IIF) !Start I
        J0A=J0AIF(IIF) !Start J
        IDA=IDAIF(IIF) !Direction
        NPA=NPAIF(IIF) !Number of nodes in the direction

        IMB=IMBIF(IIF) !Block B
        I0B=I0BIF(IIF) !Start I
        J0B=J0BIF(IIF) !Start J
        IDB=IDBIF(IIF) !Direction


        !Pointer information for the cell volumes along the edge
        K0A =I0A+ICA(IDA)+NI(IMA)*(J0A+JCA(IDA)-1)+NMP(IMA)
        K0B =I0B+ICB(IDB)+NI(IMB)*(J0B+JCB(IDB)-1)+NMP(IMB)
        K0IA=I0A         +NI(IMA)*(J0A+JCA(IDA)-1)+NMP(IMA)
        K0JA=I0A+ICA(IDA)+NI(IMA)*(J0A         -1)+NMP(IMA)
        K0IB=I0B         +NI(IMB)*(J0B+JCB(IDB)-1)+NMP(IMB)
        K0JB=I0B+ICB(IDB)+NI(IMB)*(J0B         -1)+NMP(IMB)

        !Similar coordinates in the 1D-vector along the edge
        KDA =ID(IDA)+NI(IMA)*JD(IDA)
        KDB =ID(IDB)+NI(IMB)*JD(IDB)

        !Declare vector layout
        valgA=JRS(IDA)+1
        valgB=JRS(IDB)+1

        !********
        !Block A.
        !********

        !I-direction (Startposition=I0A, step=ID(IDA))
        IF (IRS(IDA).EQ.1) THEN
               IF (J0A .GT. ( NJ(IMA)/2 )) THEN
                       !Decide startposition in the edge vector
                       !Positive if ID(IDA) > 0
                       IF (ID(IDA) .GT. 0 ) THEN
                          stepS=1
                       ELSE
                          stepS=0
                       END IF

                       DO IPP=1,NPA-1
                            !Pointer information of cell volumes and the edge face in 1D-vector
                            KCA  =K0A +KDA*(IPP-1)
                            KCB  =K0B +KDB*(IPP-1)
                            KRSIA=K0IA+KDA*(IPP-1)
                            KRSJA=K0JA+KDA*(IPP-1)
                            KRSIB=K0IB+KDB*(IPP-1)
                            KRSJB=K0JB+KDB*(IPP-1)

                            step=(IPP-stepS)*ID(IDA)
                            pos=I0A+step
                            !Save pointer information in vectors along the edge
                            boundNU(1,pos,IMA)=valgA
                            boundNU(2,pos,IMA)=KRSJA
                            boundNU(3,pos,IMA)=valgB
                            boundNU(4,pos,IMA)=KRSJB*IRS(IDB)+KRSIB*JRS(IDB)
                            boundNU(5,pos,IMA)=KCB
                            boundN(1,pos,IMA)=AJ(KRSJA)
                       END DO

               ELSE
                       IF (ID(IDA) .GT. 0 ) THEN
                          stepS=1
                       ELSE
                          stepS=0
                       END IF
                       DO IPP=1,NPA-1
                            !Pointer information of cell volumes and the edge face in 1D-vector
                            KCA  =K0A +KDA*(IPP-1)
                            KCB  =K0B +KDB*(IPP-1)
                            KRSIA=K0IA+KDA*(IPP-1)
                            KRSJA=K0JA+KDA*(IPP-1)
                            KRSIB=K0IB+KDB*(IPP-1)
                            KRSJB=K0JB+KDB*(IPP-1)

                            step=(IPP-stepS)*ID(IDA)
                            pos=I0A+step
                            !Save pointer information in vectors along the edge
                            boundSU(1,pos,IMA)=valgA
                            boundSU(2,pos,IMA)=KRSJA
                            boundSU(3,pos,IMA)=valgB
                            boundSU(4,pos,IMA)=KRSJB*IRS(IDB)+KRSIB*JRS(IDB)
                            boundSU(5,pos,IMA)=KCB
                            boundS(1,pos,IMA)=AJ(KRSJA)
                       END DO
        
               END IF !End I-direction

        !J-direction (Startposition=J0A, step=JD(IDA))
        ELSE
               IF (I0A .GT. ( NI(IMA)/2 )) THEN
                       IF (JD(IDA) .GT. 0 ) THEN
                          stepS=1
                       ELSE
                          stepS=0
                       END IF
                       DO IPP=1,NPA-1
                            !Pointer information of cell volumes and the edge face in 1D-vector
                            KCA  =K0A +KDA*(IPP-1)
                            KCB  =K0B +KDB*(IPP-1)
                            KRSIA=K0IA+KDA*(IPP-1)
                            KRSJA=K0JA+KDA*(IPP-1)
                            KRSIB=K0IB+KDB*(IPP-1)
                            KRSJB=K0JB+KDB*(IPP-1)

                            step=(IPP-stepS)*JD(IDA)
                            pos=J0A+step
                            !Save pointer information in vectors along the edge
                            boundEU(1,pos,IMA)=valgA
                            boundEU(2,pos,IMA)=KRSIA
                            boundEU(3,pos,IMA)=valgB
                            boundEU(4,pos,IMA)=KRSJB*IRS(IDB)+KRSIB*JRS(IDB)
                            boundEU(5,pos,IMA)=KCB
                            boundE(1,pos,IMA)=AI(KRSIA)
                       END DO
               ELSE
                       IF (JD(IDA) .GT. 0 ) THEN
                          stepS=1
                       ELSE
                          stepS=0
                       END IF
                       DO IPP=1,NPA-1
                            !Pointer information of cell volumes and the edge face in 1D-vector
                            KCA  =K0A +KDA*(IPP-1)
                            KCB  =K0B +KDB*(IPP-1)
                            KRSIA=K0IA+KDA*(IPP-1)
                            KRSJA=K0JA+KDA*(IPP-1)
                            KRSIB=K0IB+KDB*(IPP-1)
                            KRSJB=K0JB+KDB*(IPP-1)

                            step=(IPP-stepS)*JD(IDA)
                            pos=J0A+step
                            !Save pointer information in vectors along the edge
                            boundWU(1,pos,IMA)=valgA
                            boundWU(2,pos,IMA)=KRSIA
                            boundWU(3,pos,IMA)=valgB
                            boundWU(4,pos,IMA)=KRSJB*IRS(IDB)+KRSIB*JRS(IDB)
                            boundWU(5,pos,IMA)=KCB
                            boundW(1,pos,IMA)=AI(KRSIA)
                       END DO
        
               END IF !End J-direction

        END IF !End Block A

        !********
        !Block B.
        !********
        !I-direction (Startposition=I0B, step=ID(IDB))
        IF (IRS(IDB).EQ.1) THEN
               IF (J0B .GT. ( NJ(IMB)/2 )) THEN
                       IF (ID(IDB) .GT. 0 ) THEN
                          stepS=1
                       ELSE
                          stepS=0
                       END IF
                       DO IPP=1,NPA-1
                            !Pointer information of cell volumes and the edge face in 1D-vector
                            KCA  =K0A +KDA*(IPP-1)
                            KCB  =K0B +KDB*(IPP-1)
                            KRSIA=K0IA+KDA*(IPP-1)
                            KRSJA=K0JA+KDA*(IPP-1)
                            KRSIB=K0IB+KDB*(IPP-1)
                            KRSJB=K0JB+KDB*(IPP-1)

                            step=(IPP-stepS)*ID(IDB)
                            pos=I0B+step
                            !Save pointer information in vectors along the edge
                            boundNU(1,pos,IMB)=valgA
                            boundNU(2,pos,IMB)=KRSJA*IRS(IDA)+KRSIA*JRS(IDA)
                            boundNU(3,pos,IMB)=valgB
                            boundNU(4,pos,IMB)=KRSJB
                            boundNU(5,pos,IMB)=KCA
                            boundN(1,pos,IMB)=AJ(KRSJA)*IRS(IDA)+AI(KRSIA)*JRS(IDA)
                       END DO
               ELSE
                       IF (ID(IDB) .GT. 0 ) THEN
                          stepS=1
                       ELSE
                          stepS=0
                       END IF
                       DO IPP=1,NPA-1
                            !Pointer information of cell volumes and the edge face in 1D-vector
                            KCA  =K0A +KDA*(IPP-1)
                            KCB  =K0B +KDB*(IPP-1)
                            KRSIA=K0IA+KDA*(IPP-1)
                            KRSJA=K0JA+KDA*(IPP-1)
                            KRSIB=K0IB+KDB*(IPP-1)
                            KRSJB=K0JB+KDB*(IPP-1)

                            step=(IPP-stepS)*ID(IDB)
                            pos=I0B+step
                            !Save pointer information in vectors along the edge
                            boundSU(1,pos,IMB)=valgA
                            boundSU(2,pos,IMB)=KRSJA*IRS(IDA)+KRSIA*JRS(IDA)
                            boundSU(3,pos,IMB)=valgB
                            boundSU(4,pos,IMB)=KRSJB
                            boundSU(5,pos,IMB)=KCA
                            boundS(1,pos,IMB)=AJ(KRSJA)*IRS(IDA)+AI(KRSIA)*JRS(IDA)
                       END DO
        
               END IF !End I-direction

        !J-direction (Startposition=J0B, step=JD(IDB))
        ELSE
               IF (I0B .GT. ( NI(IMB)/2 )) THEN
                       IF (JD(IDB) .GT. 0 ) THEN
                          stepS=1
                       ELSE
                          stepS=0
                       END IF
                       DO IPP=1,NPA-1
                            !Pointer information of cell volumes and the edge face in 1D-vector
                            KCA  =K0A +KDA*(IPP-1)
                            KCB  =K0B +KDB*(IPP-1)
                            KRSIA=K0IA+KDA*(IPP-1)
                            KRSJA=K0JA+KDA*(IPP-1)
                            KRSIB=K0IB+KDB*(IPP-1)
                            KRSJB=K0JB+KDB*(IPP-1)

                            step=(IPP-stepS)*JD(IDB)
                            pos=J0B+step
                            !Save pointer information in vectors along the edge
                            boundEU(1,pos,IMB)=valgA
                            boundEU(2,pos,IMB)=KRSJA*IRS(IDA)+KRSIA*JRS(IDA)
                            boundEU(3,pos,IMB)=valgB
                            boundEU(4,pos,IMB)=KRSIB
                            boundEU(5,pos,IMB)=KCA
                            boundE(1,pos,IMB)=AJ(KRSJA)*IRS(IDA)+AI(KRSIA)*JRS(IDA)
                       END DO
               ELSE
                       IF (JD(IDB) .GT. 0 ) THEN
                          stepS=1
                       ELSE
                          stepS=0
                       END IF
                       DO IPP=1,NPA-1
                            !Pointer information of cell volumes and the edge face in 1D-vector
                            KCA  =K0A +KDA*(IPP-1)
                            KCB  =K0B +KDB*(IPP-1)
                            KRSIA=K0IA+KDA*(IPP-1)
                            KRSJA=K0JA+KDA*(IPP-1)
                            KRSIB=K0IB+KDB*(IPP-1)
                            KRSJB=K0JB+KDB*(IPP-1)

                            step=(IPP-stepS)*JD(IDB)
                            pos=J0B+step
                            !Save pointer information in vectors along the edge
                            boundWU(1,pos,IMB)=valgA
                            boundWU(2,pos,IMB)=KRSJA*IRS(IDA)+KRSIA*JRS(IDA)
                            boundWU(3,pos,IMB)=valgB
                            boundWU(4,pos,IMB)=KRSIB
                            boundWU(5,pos,IMB)=KCA
                            boundW(1,pos,IMB)=AJ(KRSJA)*IRS(IDA)+AI(KRSIA)*JRS(IDA)
                       END DO
               END IF !End J-direction

        END IF


    1 CONTINUE
  100 FORMAT(I4,6F10.3)
  101 FORMAT(10I4)

      END SUBROUTINE !End INIT_IMPLICIT


      SUBROUTINE FLUX
      USE GlobaleVariable
      implicit none

      CALL FLUX1
      IF(NIF .NE.0)CALL FLUX2
      IF(NBND.NE.0)CALL FLUX3
      CALL FLUX5
      RETURN
      END

      SUBROUTINE FLUX1                !    INTERNAL
      USE GlobaleVariable
      implicit none

! Lokale variable
      INTEGER       :: IMESH,I,J,K1,K2,K3
      DOUBLE PRECISION :: QI,QJ


      DO 1 IMESH=1,NMESH
        DO 2 J=1,NJ(IMESH)-1
        DO 2 I=1,NI(IMESH)-1
          K1=I +NI(IMESH)*(J-1)+NMP(IMESH)
          DQ(K1)=0.
   2    CONTINUE
   1  CONTINUE

      DO 3 IMESH=1,NMESH
        DO 4 J=1,NJ(IMESH)-1
        DO 4 I=1,NI(IMESH)-2
          K1=I +NI(IMESH)*(J-1)+NMP(IMESH)
          K2=K1+1
!     I- DIRECTION FLUXES
          QI=AI(K2)/RI(K2)*(TEMP(K1)-TEMP(K2))
!     UPDATE FLUX INTO CELL K2
          DQ(K2)=DQ(K2)+QI
!     UPDATE FLUX OUT OF CELL K1
          DQ(K1)=DQ(K1)-QI

   4    CONTINUE
        DO 5 J=1,NJ(IMESH)-2
        DO 5 I=1,NI(IMESH)-1
          K1=I +NI(IMESH)*(J-1)+NMP(IMESH)
          K3=K1+NI(IMESH)
!     J- DIRECTION FLUXES
          QJ=AJ(K3)/RJ(K3)*(TEMP(K1)-TEMP(K3))
!     UPDATE FLUX INTO CELL K3
          DQ(K3)=DQ(K3)+QJ
!     UPDATE FLUX OUT OF CELL K1
          DQ(K1)=DQ(K1)-QJ
   5    CONTINUE
   3  CONTINUE   

      RETURN
      END
!-----------------------------------------------------------------------
      SUBROUTINE FLUX2                 !    INTERFACES
      USE GlobaleVariable
      implicit none

! Lokale variable
      INTEGER          :: IIF,IMA,I0A,J0A,&
                          IDA,NPA,IMB,I0B,J0B,IDB,K0A,K0B,K0IA,K0JA,    &
                          K0IB,K0JB,KDA,KDB,KCA,KCB,KRSIA,KRSJA,KRSIB,  &
                          KRSJB,IPP !,k1,npb,K0AP
      DOUBLE PRECISION :: RCONDA,RCONDB,RCOND,ABND,QIF
      INTEGER, DIMENSION(4) :: ID,JD,ICA,JCA,ICB,JCB,IRS,JRS 


      DATA ID/ 1, 0,-1, 0/
      DATA JD/ 0, 1, 0,-1/
      DATA ICA/ 0,-1,-1, 0/
      DATA JCA/ 0, 0,-1,-1/
      DATA ICB/ 0, 0,-1,-1/
      DATA JCB/-1, 0, 0,-1/
      DATA IRS/ 1, 0, 1, 0/
      DATA JRS/ 0, 1, 0, 1/

!     START OUTERMOST LOOP OVER ALL INTERFACES

      DO 1 IIF=1,NIF
        IMA=IMAIF(IIF)
        I0A=I0AIF(IIF)
        J0A=J0AIF(IIF)
        IDA=IDAIF(IIF)
        NPA=NPAIF(IIF)

        IMB=IMBIF(IIF)
        I0B=I0BIF(IIF)
        J0B=J0BIF(IIF)
        IDB=IDBIF(IIF)
!      NPB=NPBIF(IIF)

!     COMPUTE NECESSARY POINTER INFORMATION

!      K0AP=I0A         +NI(IMA)*(J0A         -1)+NMP(IMA)
        K0A =I0A+ICA(IDA)+NI(IMA)*(J0A+JCA(IDA)-1)+NMP(IMA)
        K0B =I0B+ICB(IDB)+NI(IMB)*(J0B+JCB(IDB)-1)+NMP(IMB)
        K0IA=I0A         +NI(IMA)*(J0A+JCA(IDA)-1)+NMP(IMA)
        K0JA=I0A+ICA(IDA)+NI(IMA)*(J0A         -1)+NMP(IMA)
        K0IB=I0B         +NI(IMB)*(J0B+JCB(IDB)-1)+NMP(IMB)
        K0JB=I0B+ICB(IDB)+NI(IMB)*(J0B         -1)+NMP(IMB)

        KDA =ID(IDA)+NI(IMA)*JD(IDA)
        KDB =ID(IDB)+NI(IMB)*JD(IDB)

        DO 2 IPP=1,NPA-1
!          K1   =K0AP+KDA*(IPP-1)
          KCA  =K0A +KDA*(IPP-1)
          KCB  =K0B +KDB*(IPP-1)
          KRSIA=K0IA+KDA*(IPP-1)
          KRSJA=K0JA+KDA*(IPP-1)
          KRSIB=K0IB+KDB*(IPP-1)
          KRSJB=K0JB+KDB*(IPP-1)
      
          RCONDA=RJ(KRSJA)*IRS(IDA)+RI(KRSIA)*JRS(IDA)
          RCONDB=RJ(KRSJB)*IRS(IDB)+RI(KRSIB)*JRS(IDB)
          RCOND=RCONDA+RCONDB
          ABND =AJ(KRSJA)*IRS(IDA)+AI(KRSIA)*JRS(IDA)

          QIF=ABND/RCOND*(TEMP(KCA)-TEMP(KCB))
!     UPDATE FLUX INTO CELL KCB
          DQ(KCB)=DQ(KCB)+QIF
!     UPDATE FLUX OUT OF CELL KCA
          DQ(KCA)=DQ(KCA)-QIF
    2   CONTINUE
    1 CONTINUE
  100 FORMAT(I4,6F10.3)
  101 FORMAT(10I4)
      RETURN
      END
!-----------------------------------------------------------------------
      SUBROUTINE FLUX3                 !    BOUNDARIES
      USE GlobaleVariable
      implicit none

! Lokale variable
      INTEGER          :: ID,JD,IC,JC,IRS,JRS,IM,I0,J0,IDR,NP,K0,K0C,   &
                          K0I,K0J,KD,K1,KC,KRSI,KRSJ,IBND,IPP,IT
      DOUBLE PRECISION :: SIGMA,RCOND,ABND,T,HC,TU,RCONV,RADIUS,RE,ST,  &
                          RBND,RA !,TWALL,AA
      DOUBLE PRECISION :: TMIN,TMAX,T1,T2,XSI
      DOUBLE PRECISION :: TEMPJ,KONDJ,RHOJ,CPJ,ALFAJ,KINJ,PRJ
      INTEGER          :: IIMAT,N
      DIMENSION ID(4),JD(4),IC(4),JC(4),IRS(4),JRS(4)
      INTEGER :: done

      DATA ID / 1, 0,-1, 0/ 
      DATA JD / 0, 1, 0,-1/
      DATA IC / 0,-1,-1, 0/  
      DATA JC / 0, 0,-1,-1/
      DATA IRS/ 1, 0, 1, 0/
      DATA JRS/ 0, 1, 0, 1/

      SIGMA=5.67*1.E-08

      DO 1 IBND=1,NBND
        IM =IMBND(IBND)
        I0 =I0BND(IBND)
        J0 =J0BND(IBND)
        IDR=IDBND(IBND)
        NP =NPBND(IBND)
        K0 =I0        +NI(IM)*(J0        -1)+NMP(IM)
        K0C=I0+IC(IDR)+NI(IM)*(J0+JC(IDR)-1)+NMP(IM)
        K0I=I0        +NI(IM)*(J0+JC(IDR)-1)+NMP(IM)
        K0J=I0+IC(IDR)+NI(IM)*(J0        -1)+NMP(IM)
        KD= ID(IDR)+NI(IM)* JD(IDR)
        DO 2 IPP=1,NP-1
          K1  =K0 +KD*(IPP-1)
          KC  =K0C+KD*(IPP-1)
          KRSI=K0I+KD*(IPP-1)
          KRSJ=K0J+KD*(IPP-1)

          RCOND=RJ(KRSJ)*IRS(IDR)+RI(KRSI)*JRS(IDR)
          ABND =AJ(KRSJ)*IRS(IDR)+AI(KRSI)*JRS(IDR)


          IF(ITBND(IBND).EQ.1 .OR. ITBND(IBND).EQ.5)THEN
            IF(ITBND(IBND).EQ.5)THEN
              !Material hente rutine
                TEMPJ=TEMP(KC)
               	IIMAT= 6
      		N=NINT(AM_DATA(IIMAT))
      		TMIN=AM_TEMP(IIMAT,1)
      		TMAX=AM_TEMP(IIMAT,N)

      	IF(TEMPJ.LE.TMIN)THEN
        	T1=TMIN
        	T2=TMIN
        	RHOJ=AM_RO(IIMAT,1)
        	KONDJ=AM_TCJ(IIMAT,1)
                KINJ=AM_TCI(IIMAT,1)
        	CPJ=AM_CP(IIMAT,1)
      	ENDIF
      	IF(TEMPJ.GE.TMAX)THEN
        	T1=TMAX
        	T2=TMAX
        	RHOJ=AM_RO(IIMAT,N)
        	KONDJ=AM_TCJ(IIMAT,N)
                KINJ=AM_TCI(IIMAT,N)
        	CPJ=AM_CP(IIMAT,N)
      	ENDIF
      	IF(TMIN.LT.TEMPJ .AND. TEMPJ.LT.TMAX)THEN
        done=0
        DO 3 IT=1,N-1
        	T1=AM_TEMP(IIMAT,IT)
        	T2=AM_TEMP(IIMAT,IT+1)
        	XSI=(TEMPJ-T1)/(T2-T1)
        IF(T2.GT.TEMPJ .AND. done.EQ.0)THEN
   	   	RHOJ=(1.-XSI)*AM_RO(IIMAT,IT) +XSI*AM_RO(IIMAT,IT+1)
        	KONDJ=(1.-XSI)*AM_TCJ(IIMAT,IT)+XSI*AM_TCJ(IIMAT,IT+1)
                KINJ=(1.-XSI)*AM_TCI(IIMAT,IT)+XSI*AM_TCI(IIMAT,IT+1)
        	CPJ=(1.-XSI)*AM_CP(IIMAT,IT) +XSI*AM_CP(IIMAT,IT+1)
                done=1

      	ENDIF
   3    CONTINUE
        ENDIF




              ! Slutt hente gassdata


              ALFAJ=KONDJ/(RHOJ*CPJ)
              PRJ=KINJ/ALFAJ
              T=(TIME-TSTART)/(TSTOP-TSTART)
              TU=TUBND(IBND)+T*DTTUBND(IBND)
              RA=(9.81*(HCBND(IBND)**3)/(TU*KINJ*ALFAJ))*(TU-TEMP(KC))
              HC=((06+((0.387*RA**(1/6))/((1+((0.559/PRJ)**(9/16)))**(8/27))))**2)*(KONDJ/HCBND(IBND))


            !WRITE(6,*)RHOJ, CPJ, KINJ, KONDJ, ALFAJ, PRJ
             ! HC=HCBND(IBND)+T*DTHCBND(IBND)

            ELSE
              HC=HCBND(IBND)
              TU=TUBND(IBND)
            ENDIF

            RCONV=1./HC
            RBND=RCONV+RCOND

            DQ(KC)=DQ(KC)+ABND/RBND*(TU-TEMP(KC))
          ENDIF

          IF(ITBND(IBND).EQ.2)THEN
            DQ(KC)=DQ(KC)+QBND(IBND)*ABND
          ENDIF

          IF(ITBND(IBND).EQ.3)THEN     !internal heat transfer
            RADIUS=YM(K1)
            RE=UBND(IBND,IPP)*RADIUS/VISCBND(IBND,IPP)
            ST=0.0791/RE**0.25*0.5/                                         &
               (1.+1.99*RE**(-0.125)*(PRBND(IBND,IPP)-1))
            HC=ROBND(IBND,IPP)*UBND(IBND,IPP)*CPBND(IBND,IPP)*ST
            RCONV=1./HC
            RBND=RCONV+RCOND
            DQ(KC)=DQ(KC)+ABND/RBND*(TUBND(IBND)-TEMP(KC))
          ENDIF
          IF(ITBND(IBND).EQ.4.OR.ITBND(IBND).EQ.6)THEN
            RCONV=1./HCEBND(IBND,IPP)
            RBND=RCONV+RCOND
            DQ(KC)=DQ(KC)+ABND/RBND*(TRBND(IBND,IPP)-TEMP(KC))
          ENDIF

          IF(IRADBND(IBND).EQ.1)THEN   !add radiation heat transfer
!            TWALL=TEMP(KC)    !0 ORDENS TILNARMING BOR FORBEDRES
            DQ(KC)=DQ(KC)+ABND*SIGMA*EMSBND(IBND)*                          &
                          ((TRADBND(IBND))**4-(TEMP(KC))**4)
!            aa=ABND*SIGMA*EMSBND(IBND)*(0-(TEMP(KC))**4)
          ENDIF

          !Konstant temperatur p grense
          IF(ITBND(IBND).EQ.7) THEN
            RBND=RCOND
            DQ(KC)=DQ(KC)+ABND/RBND*(TUBND(IBND)-TEMP(KC))

          END IF


    2   CONTINUE
    1 CONTINUE

  100 FORMAT(2I4,6F10.3)
      RETURN
      END
!-----------------------------------------------------------------------
      SUBROUTINE FLUX5
      USE GlobaleVariable
      implicit none

! Lokale variable
      INTEGER          :: IMESH,I,J,K


      DO 1 IMESH=1,NMESH
        DO 2 J=1,NJ(IMESH)-1
        DO 2 I=1,NI(IMESH)-1
          K=I +NI(IMESH)*(J-1)+NMP(IMESH)
          DTEMP(K)=DQ(K)/(RO(K)*C(K)*VOL(K))*TSF
   2    CONTINUE
   1  CONTINUE
      RETURN
      END

      SUBROUTINE STEP(ISTEP)
      USE GlobaleVariable
      implicit none
      INTEGER          :: ISTEP

! Lokale variable
      INTEGER          :: IMESH,I,J,K,IPR
      


      IPR=MOD(ISTEP,25)
      IF(ISTEP.EQ.1)IPR=0
      IF(IPR.EQ.0)THEN
        CALL PICKMDATA
        CALL RESMAT
        CALL LTSP
      ENDIF

      CALL FLUX
      
      DO 3 IMESH=1,NMESH
        DO 4 J=1,NJ(IMESH)-1
        DO 4 I=1,NI(IMESH)-1
          K=I+NI(IMESH)*(J-1)+NMP(IMESH)
         TEMP(K)=TEMP(K)+CFL*DTEMP(K)
    4   CONTINUE
    3 CONTINUE
      RETURN
      END

!-----------------------------------------------------------------------------
    SUBROUTINE MATRSAVE
    USE GlobaleVariable
    IMPLICIT NONE

    ! LOKALE VARIABLE
    INTEGER          :: IMesh, I,J,K,L

    L=1
    OPEN(50,FILE=MATRFIL,FORM='FORMATTED',STATUS='REPLACE')
    WRITE (50,*) 'TITLE = "MATERIAL"'
    WRITE (50,*) 'VARIABLES = "X","Y","Matr"'

    DO IMESH=1,NMESH
      WRITE(50,*) 'ZONE F=POINT, I=',NI(IMESH),',J=',NJ(IMESH)
      DO J=1,NJ(IMESH)
        DO I=1,NI(IMESH)
         K=I+NI(IMESH)*(J-1)+NMP(IMESH)
         WRITE(50,*) XM(L),YM(L),Mat(K)
         L=L+1
        ENDDO
      ENDDO
    ENDDO

    RETURN
    END SUBROUTINE

      SUBROUTINE MATERIALS
      USE GlobaleVariable
      IMPLICIT NONE


! Lokale variable
      INTEGER          :: IREG,IM,NMPL,NIL,I,J,K!,NJL



      DO 3 IREG=1,NREG
      IM=IMR(IREG)
      NMPL=NMP(IM)
      NIL = NI(IM)
!      NJL = NJ(IM)
      DO 4 J=JR1(IREG),JR2(IREG)-1
      DO 4 I=IR1(IREG),IR2(IREG)-1
      K=I+NIL*(J-1)+NMPL
      MAT(K)=IMAT(IREG)
    4 CONTINUE
    3 CONTINUE
      RETURN
      END
!-----------------------------------------------------------------------
      SUBROUTINE RESMAT
      USE GlobaleVariable
      IMPLICIT NONE

! Lokale variable
      INTEGER          :: IMESH,I,J,K1,K2,K3
      DOUBLE PRECISION :: R1,R2


      DO IMESH=1,NMESH
       DO J=1,NJ(IMESH)-1
        DO I=1,NI(IMESH)-1
         K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
         K2=K1+1
         K3=K1+NI(IMESH)
!        I- DIRECTION RESISTANCE
         IF (I.EQ.1) THEN
           RI(K1)=.5*DI(K1)/TCI(K1)
         END IF
         IF (I.EQ.(NI(IMESH)-1)) THEN
           RI(K2)=.5*DI(K1)/TCI(K1)
         ELSE
           R1=.5*DI(K1)/TCI(K1)
           R2=.5*DI(K2)/TCI(K2)
           RI(K2)=R1+R2
         END IF
!        J- DIRECTION RESISTANCE
         IF (J.EQ.1) THEN
           RJ(K1)=.5*DJ(K1)/TCJ(K1)
         END IF
         IF (J.EQ.(NJ(IMESH)-1)) THEN
           RJ(K3)=.5*DJ(K1)/TCJ(K1)
         ELSE
           R1=.5*DJ(K1)/TCJ(K1)
           R2=.5*DJ(K3)/TCJ(K3)
           RJ(K3)=R1+R2
         END IF
        END DO
       END DO
      END DO

      RETURN
      END
!-----------------------------------------------------------------------
      SUBROUTINE PICKMDATA
      USE GlobaleVariable
      IMPLICIT NONE
! Lokale variable
      INTEGER          :: I,J,IMESH,K1,IIMAT,N,IT
      DOUBLE PRECISION :: T,TMIN,TMAX,T1,T2,XSI



      DO IMESH=1,NMESH
       DO J=1,NJ(IMESH)-1
        DO I=1,NI(IMESH)-1
         K1=I+NI(IMESH)*(J-1)+NMP(IMESH)
         T=TEMP(K1)
         IIMAT=MAT(K1)
         N=NINT(AM_DATA(IIMAT))
         TMIN=AM_TEMP(IIMAT,1)
         TMAX=AM_TEMP(IIMAT,N)
         IF (T.LE.TMIN) THEN
           T1=TMIN
           T2=TMIN
           RO(K1) =AM_RO(IIMAT,1)
           TCI(K1)=AM_TCI(IIMAT,1)
           TCJ(K1)=AM_TCJ(IIMAT,1)
           C(K1)  =AM_CP(IIMAT,1)
         ELSE IF (T.GE.TMAX) THEN
           T1=TMAX
           T2=TMAX
           RO(K1) =AM_RO(IIMAT,N)
           TCI(K1)=AM_TCI(IIMAT,N)
           TCJ(K1)=AM_TCJ(IIMAT,N)
           C(K1)  =AM_CP(IIMAT,N)
         ELSE
           DO IT=1,N-1
             T1=AM_TEMP(IIMAT,IT)
             T2=AM_TEMP(IIMAT,IT+1)
             XSI=(T-T1)/(T2-T1)
             IF(T2.GT.T)EXIT
           END DO
           RO(K1) =(1.-XSI)*AM_RO(IIMAT,IT) +XSI*AM_RO(IIMAT,IT+1)
           TCI(K1)=(1.-XSI)*AM_TCI(IIMAT,IT)+XSI*AM_TCI(IIMAT,IT+1)
           TCJ(K1)=(1.-XSI)*AM_TCJ(IIMAT,IT)+XSI*AM_TCJ(IIMAT,IT+1)
           C(K1)  =(1.-XSI)*AM_CP(IIMAT,IT) +XSI*AM_CP(IIMAT,IT+1)
         END IF
        END DO !End I
       END DO !End J
      END DO !End MESH

      RETURN
      END
!-----------------------------------------------------------------------
      SUBROUTINE DEFMATDATA
      USE GlobaleVariable
      IMPLICIT NONE

! aluminium (Typiske data for legert Al)
      AM_DATA(1)=5
      AM_TEMP(1,1)=  -100.+273.15
      AM_TEMP(1,2)=  273.15+ 20.
      AM_TEMP(1,3)=  273.15+ 100.
      AM_TEMP(1,4)=  273.15+ 200.
      AM_TEMP(1,5)=  273.15+ 300.

      AM_CP  (1,1)=   955.
      AM_CP  (1,2)=   960.
      AM_CP  (1,3)=   962.
      AM_CP  (1,4)=   967.
      AM_CP  (1,5)=   983.

      AM_TCI (1,1)=   110.
      AM_TCI (1,2)=   130.
      AM_TCI (1,3)=   148.
      AM_TCI (1,4)=   168.
      AM_TCI (1,5)=   188.

      AM_TCJ (1,1)=   110.
      AM_TCJ (1,2)=   130.
      AM_TCJ (1,3)=   148.
      AM_TCJ (1,4)=   168.
      AM_TCJ (1,5)=   188.

      AM_RO  (1,1)=  1758.
      AM_RO  (1,2)=  1758.
      AM_RO  (1,3)=  1758.
      AM_RO  (1,4)=  1758.
      AM_RO  (1,5)=  1758.
! titan (Typiske data for Ti-legering)
      AM_DATA(9)=6
      AM_TEMP(9,1)=  -173.+273.15
      AM_TEMP(9,2)=  273.15+  25.
      AM_TEMP(9,3)=  273.15+ 100.
      AM_TEMP(9,4)=  273.15+ 204.
      AM_TEMP(9,5)=  273.15+ 426.
      AM_TEMP(9,6)=  273.15+ 648.

      AM_CP  (9,1)=   298.2
      AM_CP  (9,2)=   523.3
      AM_CP  (9,3)=   546.2
      AM_CP  (9,4)=   569.
      AM_CP  (9,5)=   609.8
      AM_CP  (9,6)=   660.4

      AM_TCI (9,1)=    31.2
      AM_TCI (9,2)=    21.9
      AM_TCI (9,3)=    20.7
      AM_TCI (9,4)=    20.1
      AM_TCI (9,5)=    19.5
      AM_TCI (9,6)=    16.3

      AM_TCJ (9,1)=    31.2
      AM_TCJ (9,2)=    21.9
      AM_TCJ (9,3)=    20.7
      AM_TCJ (9,4)=    20.1
      AM_TCJ (9,5)=    19.5
      AM_TCJ (9,6)=    16.3

      AM_RO  (9,1)=  4500.
      AM_RO  (9,2)=  4500.
      AM_RO  (9,3)=  4500.
      AM_RO  (9,4)=  4500.
      AM_RO  (9,5)=  4500.
      AM_RO  (9,6)=  4500.
! steel (Typiske data .. ser ut som karbonstl)
      AM_DATA(2)=5
      AM_TEMP(2,1)=   -56.+273.15
      AM_TEMP(2,2)=   204. +273.15
      AM_TEMP(2,3)=   426. +273.15
      AM_TEMP(2,4)=   648. +273.15
      AM_TEMP(2,5)=  1500. +273.15

      AM_CP  (2,1)=   419.
      AM_CP  (2,2)=   519.
      AM_CP  (2,3)=   620.
      AM_CP  (2,4)=   754.
      AM_CP  (2,5)=   800.

      AM_TCI (2,1)=    43.1
      AM_TCI (2,2)=    42.2
      AM_TCI (2,3)=    38.6
      AM_TCI (2,4)=    32.2
      AM_TCI (2,5)=    25.0

      AM_TCJ (2,1)=    43.1
      AM_TCJ (2,2)=    42.2
      AM_TCJ (2,3)=    38.6
      AM_TCJ (2,4)=    32.2
      AM_TCJ (2,5)=    25.0

      AM_RO  (2,1)=  7745.
      AM_RO  (2,2)=  7745.
      AM_RO  (2,3)=  7745.
      AM_RO  (2,4)=  7745.
      AM_RO  (2,5)=  7745.

! SiPh (Inkludererer effekt av forgassing/forkulling)
      AM_DATA(3)=10
      AM_TEMP(3, 1)= 21. +273.15
      AM_TEMP(3, 2)= 149.+273.15
      AM_TEMP(3, 3)=   371.   +273.15
      AM_TEMP(3, 4)=   560.   +273.15
      AM_TEMP(3, 5)=   838.   +273.15
      AM_TEMP(3, 6)=  1115.   +273.15
      AM_TEMP(3, 7)=  1393.   +273.15
      AM_TEMP(3, 8)=  1949.   +273.15
      AM_TEMP(3, 9)=  2504.   +273.15
      AM_TEMP(3,10)=  3060.   +273.15

      AM_CP  (3, 1)=   754.
      AM_CP  (3, 2)=  1005.
      AM_CP  (3, 3)=  1193.
      AM_CP  (3, 4)=  2190.
      AM_CP  (3, 5)=  2400.
      AM_CP  (3, 6)=  1298.
      AM_CP  (3, 7)=  1486.
      AM_CP  (3, 8)=  1486.
      AM_CP  (3, 9)=  1486.
      AM_CP  (3,10)=  1486.

      AM_TCI (3, 1)=     0.459
      AM_TCI (3, 2)=     0.513
      AM_TCI (3, 3)=     0.600
      AM_TCI (3, 4)=     0.627
      AM_TCI (3, 5)=     0.750
      AM_TCI (3, 6)=     0.850
      AM_TCI (3, 7)=     1.000
      AM_TCI (3, 8)=     1.812
      AM_TCI (3, 9)=     3.744

      AM_TCI (3,10)=     6.678
      AM_TCJ (3, 1)=     0.303
      AM_TCJ (3, 2)=     0.337
      AM_TCJ (3, 3)=     0.396
      AM_TCJ (3, 4)=     0.400
      AM_TCJ (3, 5)=     0.439
      AM_TCJ (3, 6)=     0.461
      AM_TCJ (3, 7)=     0.492
      AM_TCJ (3, 8)=     1.022
      AM_TCJ (3, 9)=     2.819
      AM_TCJ (3,10)=     3.112

      AM_RO  (3, 1)=  1758.
      AM_RO  (3, 2)=  1758.
      AM_RO  (3, 3)=  1758.
      AM_RO  (3, 4)=  1672.
      AM_RO  (3, 5)=  1548.
      AM_RO  (3, 6)=  1548.
      AM_RO  (3, 7)=  1548.
      AM_RO  (3, 8)=  1548.
      AM_RO  (3, 9)=  1548.
      AM_RO  (3,10)=  1548.

! SiPh    COOLING PHASE
      AM_DATA(11)=10
      AM_TEMP(11, 1)=   21.+273.15
      AM_TEMP(11, 2)=  149.+273.15
      AM_TEMP(11, 3)=  371.+273.15
      AM_TEMP(11, 4)=  560.+273.15
      AM_TEMP(11, 5)=  838.+273.15
      AM_TEMP(11, 6)= 1115.+273.15
      AM_TEMP(11, 7)= 1393.+273.15
      AM_TEMP(11, 8)= 1949.+273.15
      AM_TEMP(11, 9)= 2504.+273.15
      AM_TEMP(11,10)= 3060.+273.15

      AM_CP  (11, 1)=  754.
      AM_CP  (11, 2)= 1005.
      AM_CP  (11, 3)= 1193.
      AM_CP  (11, 4)= 1200.
      AM_CP  (11, 5)= 1250.
      AM_CP  (11, 6)= 1298.
      AM_CP  (11, 7)= 1486.
      AM_CP  (11, 8)= 1486.
      AM_CP  (11, 9)= 1486.
      AM_CP  (11,10)= 1486.

      AM_TCI (11, 1)=    0.459
      AM_TCI (11, 2)=    0.513
      AM_TCI (11, 3)=    0.600
      AM_TCI (11, 4)=    0.627
      AM_TCI (11, 5)=    0.750
      AM_TCI (11, 6)=    0.850
      AM_TCI (11, 7)=    1.000
      AM_TCI (11, 8)=    1.812
      AM_TCI (11, 9)=    3.744
      AM_TCI (11,10)=    6.678

      AM_TCJ (11, 1)=    0.303
      AM_TCJ (11, 2)=    0.337
      AM_TCJ (11, 3)=    0.396
      AM_TCJ (11, 4)=    0.400
      AM_TCJ (11, 5)=    0.439
      AM_TCJ (11, 6)=    0.461
      AM_TCJ (11, 7)=    0.492
      AM_TCJ (11, 8)=    1.022
      AM_TCJ (11, 9)=    2.819
      AM_TCJ (11,10)=    3.112

      AM_RO  (11, 1)= 1758.
      AM_RO  (11, 2)= 1758.
      AM_RO  (11, 3)= 1758.
      AM_RO  (11, 4)= 1672.
      AM_RO  (11, 5)= 1548.
      AM_RO  (11, 6)= 1548.
      AM_RO  (11, 7)= 1548.
      AM_RO  (11, 8)= 1548.
      AM_RO  (11, 9)= 1548.
      AM_RO  (11,10)= 1548.

! Molybden
      AM_DATA(4)=10
      AM_TEMP(4, 1)=  -100.+273.15
      AM_TEMP(4, 2)=     0.+273.15
      AM_TEMP(4, 3)=   100.+273.15
      AM_TEMP(4, 4)=   200.+273.15
      AM_TEMP(4, 5)=   300.+273.15
      AM_TEMP(4, 6)=   400.+273.15
      AM_TEMP(4, 7)=   600.+273.15
      AM_TEMP(4, 8)=   800.+273.15
      AM_TEMP(4, 9)=  1000.+273.15
      AM_TEMP(4,10)=  2500.+273.15

      AM_CP  (4, 1)=   250.
      AM_CP  (4, 2)=   255.
      AM_CP  (4, 3)=   260.
      AM_CP  (4, 4)=   265.
      AM_CP  (4, 5)=   270.
      AM_CP  (4, 6)=   275.
      AM_CP  (4, 7)=   280.
      AM_CP  (4, 8)=   285.
      AM_CP  (4, 9)=   290.
      AM_CP  (4,10)=   350.

      AM_TCI (4, 1)=   138.
      AM_TCI (4, 2)=   125.
      AM_TCI (4, 3)=   118.
      AM_TCI (4, 4)=   114.
      AM_TCI (4, 5)=   111.
      AM_TCI (4, 6)=   109.
      AM_TCI (4, 7)=   106.
      AM_TCI (4, 8)=   102.
      AM_TCI (4, 9)=    99.
      AM_TCI (4,10)=    75.

      AM_TCJ (4, 1)=   138.
      AM_TCJ (4, 2)=   125.
      AM_TCJ (4, 3)=   118.
      AM_TCJ (4, 4)=   114.
      AM_TCJ (4, 5)=   111.
      AM_TCJ (4, 6)=   109.
      AM_TCJ (4, 7)=   106.
      AM_TCJ (4, 8)=   102.
      AM_TCJ (4, 9)=    99.
      AM_TCJ (4,10)=    75.

      AM_RO  (4, 1)= 10220.
      AM_RO  (4, 2)= 10220.
      AM_RO  (4, 3)= 10220.
      AM_RO  (4, 4)= 10220.
      AM_RO  (4, 5)= 10220.
      AM_RO  (4, 6)= 10220.
      AM_RO  (4, 7)= 10220.
      AM_RO  (4, 8)= 10220.
      AM_RO  (4, 9)= 10220.
      AM_RO  (4,10)= 10220.

! EPDM (kun "rene" termiske egenskaper; ikke kompensert for forgassing/forkulling)
      AM_DATA(5)=10
      AM_TEMP(5, 1)=  -73.+273.15
      AM_TEMP(5, 2)=  -18.+273.15
      AM_TEMP(5, 3)=   10.+273.15
      AM_TEMP(5, 4)=   94.+273.15
      AM_TEMP(5, 5)=  200.+273.15
      AM_TEMP(5, 6)=  315.+273.15
      AM_TEMP(5, 7)=  455.+273.15
      AM_TEMP(5, 8)=  594.+273.15
      AM_TEMP(5, 9)= 1093.+273.15
      AM_TEMP(5,10)= 3316.+273.15

      AM_CP  (5, 1)= 1000.
      AM_CP  (5, 2)= 1330.
      AM_CP  (5, 3)= 1280.
      AM_CP  (5, 4)= 1520.
      AM_CP  (5, 5)= 1890.
      AM_CP  (5, 6)= 2020.
      AM_CP  (5, 7)= 2902.
      AM_CP  (5, 8)= 2300.
      AM_CP  (5, 9)= 2050.
      AM_CP  (5,10)= 2050.

      AM_TCI (5, 1)=     .230
      AM_TCI (5, 2)=     .213
      AM_TCI (5, 3)=     .204
      AM_TCI (5, 4)=     .171
      AM_TCI (5, 5)=     .147
      AM_TCI (5, 6)=     .121
      AM_TCI (5, 7)=     .113
      AM_TCI (5, 8)=     .104
      AM_TCI (5, 9)=     .100
      AM_TCI (5,10)=     .100

      AM_TCJ (5, 1)=     .230
      AM_TCJ (5, 2)=     .213
      AM_TCJ (5, 3)=     .204
      AM_TCJ (5, 4)=     .171
      AM_TCJ (5, 5)=     .147
      AM_TCJ (5, 6)=     .121
      AM_TCJ (5, 7)=     .113
      AM_TCJ (5, 8)=     .104
      AM_TCJ (5, 9)=     .100
      AM_TCJ (5,10)=     .100

      AM_RO  (5, 1)= 1100.
      AM_RO  (5, 2)= 1100.
      AM_RO  (5, 3)= 1100.
      AM_RO  (5, 4)= 1100.
      AM_RO  (5, 5)= 1100.
      AM_RO  (5, 6)= 1100.
      AM_RO  (5, 7)=  715.
      AM_RO  (5, 8)=  325.
      AM_RO  (5, 9)=  325.
      AM_RO  (5,10)=  325.

! Luft
      AM_DATA(6)=11
      AM_TEMP(6,1)=	300
      AM_TEMP(6,2)=     350
      AM_TEMP(6,3)=     400
      AM_TEMP(6,4)=     550
      AM_TEMP(6,5)=     600
      AM_TEMP(6,6)=     650
      AM_TEMP(6,7)=     700
      AM_TEMP(6,8)=     800
      AM_TEMP(6,9)=    1000
      AM_TEMP(6,10)=   1200
      AM_TEMP(6,11)=   1600

      AM_CP  (6,1)=   1007.
      AM_CP  (6,2)=   1009.
      AM_CP  (6,3)=   1014.
      AM_CP  (6,4)=   1040.
      AM_CP  (6,5)=   1051.
      AM_CP  (6,6)=   1063.
      AM_CP  (6,7)=   1075.
      AM_CP  (6,8)=   1099.
      AM_CP  (6,9)=   1142.
      AM_CP  (6,10)=  1172.
      AM_CP  (6,11)=  1248.

      AM_TCI (6,1)=       0.00001589
      AM_TCI (6,2)=       0.00002092
      AM_TCI (6,3)=       0.00002641
      AM_TCI (6,4)=       0.00004557
      AM_TCI (6,5)=       0.00005269
      AM_TCI (6,6)=       0.00006021
      AM_TCI (6,7)=       0.00006810
      AM_TCI (6,8)=       0.00008493
      AM_TCI (6,9)=       0.00012190
      AM_TCI (6,10)=      0.00016290
      AM_TCI (6,11)=      0.00026800

      AM_TCJ (6,1)=       0.0263
      AM_TCJ (6,2)=       0.0300
      AM_TCJ (6,3)=       0.0338
      AM_TCJ (6,4)=       0.0439
      AM_TCJ (6,5)=       0.0469
      AM_TCJ (6,6)=       0.0497
      AM_TCJ (6,7)=       0.0524
      AM_TCJ (6,8)=       0.0573
      AM_TCJ (6,9)=       0.0667
      AM_TCJ (6,10)=      0.0763
      AM_TCJ (6,11)=      0.1060

      AM_RO  (6,1)=      1.1614
      AM_RO  (6,2)=      0.9950
      AM_RO  (6,3)=      0.8711
      AM_RO  (6,4)=      0.6329
      AM_RO  (6,5)=      0.5804
      AM_RO  (6,6)=      0.5356
      AM_RO  (6,7)=      0.4975
      AM_RO  (6,8)=      0.4354
      AM_RO  (6,9)=      0.3482
      AM_RO  (6,10)=     0.2902
      AM_RO  (6,11)=     0.2177

! ARAMIDE-EPOXY
      AM_DATA(7)=9

      AM_TEMP(7, 1)=   -50.+273.15
      AM_TEMP(7, 2)=     0.+273.15
      AM_TEMP(7, 3)=    50.+273.15
      AM_TEMP(7, 4)=   100.+273.15
      AM_TEMP(7, 5)=   150.+273.15
      AM_TEMP(7, 6)=   200.+273.15
      AM_TEMP(7, 7)=   250.+273.15
      AM_TEMP(7, 8)=   300.+273.15
      AM_TEMP(7, 9)=   500.+273.15

      AM_CP  (7, 1)=   858.
      AM_CP  (7, 2)=  1080.
      AM_CP  (7, 3)=  1382.
      AM_CP  (7, 4)=  1696.
      AM_CP  (7, 5)=  1696.
      AM_CP  (7, 6)=  2198.
      AM_CP  (7, 7)=  2303.
      AM_CP  (7, 8)=  2382.
      AM_CP  (7, 9)=  2400.

      AM_TCI (7, 1)=      .198
      AM_TCI (7, 2)=      .210
      AM_TCI (7, 3)=      .214
      AM_TCI (7, 4)=      .217
      AM_TCI (7, 5)=      .217
      AM_TCI (7, 6)=      .206
      AM_TCI (7, 7)=      .154
      AM_TCI (7, 8)=      .100
      AM_TCI (7, 9)=      .070

      AM_TCJ (7, 1)=      .198
      AM_TCJ (7, 2)=      .210
      AM_TCJ (7, 3)=      .214
      AM_TCJ (7, 4)=      .217
      AM_TCJ (7, 5)=      .217
      AM_TCJ (7, 6)=      .206
      AM_TCJ (7, 7)=      .154
      AM_TCJ (7, 8)=      .100
      AM_TCJ (7, 9)=      .070

      AM_RO  (7, 1)=  1380.
      AM_RO  (7, 2)=  1380.
      AM_RO  (7, 3)=  1380.
      AM_RO  (7, 4)=  1380.
      AM_RO  (7, 5)=  1380.
      AM_RO  (7, 6)=  1380.
      AM_RO  (7, 7)=  1380.
      AM_RO  (7, 8)=  1380.
      AM_RO  (7, 9)=  1380.

! grain
      AM_DATA(8)=6
      AM_TEMP(8,1)=  -100.+273.15
      AM_TEMP(8,2)=    20.+273.15
      AM_TEMP(8,3)=    77.+273.15
      AM_TEMP(8,4)=   149.+273.15
      AM_TEMP(8,5)=   200.+273.15
      AM_TEMP(8,6)=   371.+273.15

      AM_CP  (8,1)=  1047.
      AM_CP  (8,2)=  1047.
      AM_CP  (8,3)=  1336.
      AM_CP  (8,4)=  1336.
      AM_CP  (8,5)=  1532.
      AM_CP  (8,6)=  1570.

      AM_TCI (8,1)=      .36
      AM_TCI (8,2)=      .36
      AM_TCI (8,3)=      .36
      AM_TCI (8,4)=      .36
      AM_TCI (8,5)=      .36
      AM_TCI (8,6)=      .36

      AM_TCJ (8,1)=      .36
      AM_TCJ (8,2)=      .36
      AM_TCJ (8,3)=      .36
      AM_TCJ (8,4)=      .36
      AM_TCJ (8,5)=      .36
      AM_TCJ (8,6)=      .36

      AM_RO  (8,1)=  1722.
      AM_RO  (8,2)=  1722.
      AM_RO  (8,3)=  1722.
      AM_RO  (8,4)=  1722.
      AM_RO  (8,5)=  1722.
      AM_RO  (8,6)=  1722.
! graphite
      AM_DATA(10)=3
      AM_TEMP(10,1)= -100.+273.15
      AM_TEMP(10,2)=   20.+273.15
      AM_TEMP(10,3)= 3000.+273.15

      AM_CP  (10,1)= 2500.
      AM_CP  (10,2)= 2500.
      AM_CP  (10,3)= 2500.

      AM_TCI (10,1)= 1163.
      AM_TCI (10,2)= 1163.
      AM_TCI (10,3)= 1163.

      AM_TCJ (10,1)= 1163.
      AM_TCJ (10,2)= 1163.
      AM_TCJ (10,3)= 1163.

      AM_RO  (10,1)= 1750.
      AM_RO  (10,2)= 1750.
      AM_RO  (10,3)= 1750.

! Carbon fiber composite, intermediate modulus (IM-7)

      AM_DATA(12)=3
      AM_TEMP(12,1)= -100.+273.15
      AM_TEMP(12,2)=   20.+273.15
      AM_TEMP(12,3)= 3000.+273.15

      AM_CP  (12,1)=  750.
      AM_CP  (12,2)=  750.
      AM_CP  (12,3)=  750.

      AM_TCI (12,1)=    6.
      AM_TCI (12,2)=    6.
      AM_TCI (12,3)=    6.

      AM_TCJ (12,1)=     .6
      AM_TCJ (12,2)=     .6
      AM_TCJ (12,3)=     .6

      AM_RO  (12,1)= 1600.
      AM_RO  (12,2)= 1600.
      AM_RO  (12,3)= 1600.

! TZM (Molybdenlegering: Mo:0.4-0.55, Ti:0.06-1.2, Zr:0.01-0.04) (Plansee)
      AM_DATA(13)=26
      AM_TEMP(13, 1)=    0.+273.15
      AM_TEMP(13, 2)=  100.+273.15
      AM_TEMP(13, 3)=  200.+273.15
      AM_TEMP(13, 4)=  300.+273.15
      AM_TEMP(13, 5)=  400.+273.15
      AM_TEMP(13, 6)=  500.+273.15
      AM_TEMP(13, 7)=  600.+273.15
      AM_TEMP(13, 8)=  700.+273.15
      AM_TEMP(13, 9)=  800.+273.15
      AM_TEMP(13,10)=  900.+273.15
      AM_TEMP(13,11)= 1000.+273.15
      AM_TEMP(13,12)= 1100.+273.15
      AM_TEMP(13,13)= 1200.+273.15
      AM_TEMP(13,14)= 1300.+273.15
      AM_TEMP(13,15)= 1400.+273.15
      AM_TEMP(13,16)= 1500.+273.15
      AM_TEMP(13,17)= 1600.+273.15
      AM_TEMP(13,18)= 1700.+273.15
      AM_TEMP(13,19)= 1800.+273.15
      AM_TEMP(13,20)= 1900.+273.15
      AM_TEMP(13,21)= 2000.+273.15
      AM_TEMP(13,22)= 2100.+273.15
      AM_TEMP(13,23)= 2200.+273.15
      AM_TEMP(13,24)= 2300.+273.15
      AM_TEMP(13,25)= 2400.+273.15
      AM_TEMP(13,26)= 2500.+273.15

      AM_CP  (13, 1)=  229.5
      AM_CP  (13, 2)=  231.3
      AM_CP  (13, 3)=  236.7
      AM_CP  (13, 4)=  242.1
      AM_CP  (13, 5)=  247.5
      AM_CP  (13, 6)=  256.5
      AM_CP  (13, 7)=  263.7
      AM_CP  (13, 8)=  272.7
      AM_CP  (13, 9)=  279.9
      AM_CP  (13,10)=  288.8
      AM_CP  (13,11)=  296.
      AM_CP  (13,12)=  303.2
      AM_CP  (13,13)=  312.2
      AM_CP  (13,14)=  319.4
      AM_CP  (13,15)=  328.4
      AM_CP  (13,16)=  337.4
      AM_CP  (13,17)=  348.2
      AM_CP  (13,18)=  360.8
      AM_CP  (13,19)=  373.4
      AM_CP  (13,20)=  389.6
      AM_CP  (13,21)=  404.
      AM_CP  (13,22)=  421.6
      AM_CP  (13,23)=  441.7
      AM_CP  (13,24)=  461.8
      AM_CP  (13,25)=  481.9
      AM_CP  (13,26)=  502.

      AM_TCI (13, 1)=  128.49
      AM_TCI (13, 2)=  125.69
      AM_TCI (13, 3)=  122.9
      AM_TCI (13, 4)=  120.11
      AM_TCI (13, 5)=  118.01
      AM_TCI (13, 6)=  115.57
      AM_TCI (13, 7)=  113.12
      AM_TCI (13, 8)=  111.03
      AM_TCI (13, 9)=  108.24
      AM_TCI (13,10)=  106.14
      AM_TCI (13,11)=  103.35
      AM_TCI (13,12)=  100.21
      AM_TCI (13,13)=   97.76
      AM_TCI (13,14)=   94.62
      AM_TCI (13,15)=   92.18
      AM_TCI (13,16)=   89.03
      AM_TCI (13,17)=   86.24
      AM_TCI (13,18)=   83.45
      AM_TCI (13,19)=   81.
      AM_TCI (13,20)=   78.21
      AM_TCI (13,21)=   75.42
      AM_TCI (13,22)=   72.97
      AM_TCI (13,23)=   71.23
      AM_TCI (13,24)=   69.48
      AM_TCI (13,25)=   68.43
      AM_TCI (13,26)=   67.04

      AM_TCJ (13, 1)=  128.49
      AM_TCJ (13, 2)=  125.69
      AM_TCJ (13, 3)=  122.9
      AM_TCJ (13, 4)=  120.11
      AM_TCJ (13, 5)=  118.01
      AM_TCJ (13, 6)=  115.57
      AM_TCJ (13, 7)=  113.12
      AM_TCJ (13, 8)=  111.03
      AM_TCJ (13, 9)=  108.24
      AM_TCJ (13,10)=  106.14
      AM_TCJ (13,11)=  103.35
      AM_TCJ (13,12)=  100.21
      AM_TCJ (13,13)=   97.76
      AM_TCJ (13,14)=   94.62
      AM_TCJ (13,15)=   92.18
      AM_TCJ (13,16)=   89.03
      AM_TCJ (13,17)=   86.24
      AM_TCJ (13,18)=   83.45
      AM_TCJ (13,19)=   81.
      AM_TCJ (13,20)=   78.21
      AM_TCJ (13,21)=   75.42
      AM_TCJ (13,22)=   72.97
      AM_TCJ (13,23)=   71.23
      AM_TCJ (13,24)=   69.48
      AM_TCJ (13,25)=   68.43
      AM_TCJ (13,26)=   67.04

      AM_RO  (13, 1)=10220.
      AM_RO  (13, 2)=10220.
      AM_RO  (13, 3)=10220.
      AM_RO  (13, 4)=10220.
      AM_RO  (13, 5)=10220.
      AM_RO  (13, 6)=10220.
      AM_RO  (13, 7)=10220.
      AM_RO  (13, 8)=10220.
      AM_RO  (13, 9)=10220.
      AM_RO  (13,10)=10220.
      AM_RO  (13,11)=10220.
      AM_RO  (13,12)=10220.
      AM_RO  (13,13)=10220.
      AM_RO  (13,14)=10220.
      AM_RO  (13,15)=10220.
      AM_RO  (13,16)=10220.
      AM_RO  (13,17)=10220.
      AM_RO  (13,18)=10220.
      AM_RO  (13,19)=10220.
      AM_RO  (13,20)=10220.
      AM_RO  (13,21)=10220.
      AM_RO  (13,22)=10220.
      AM_RO  (13,23)=10220.
      AM_RO  (13,24)=10220.
      AM_RO  (13,25)=10220.
      AM_RO  (13,26)=10220.

! WL10 (Tungstenlegering) (Tungsten+1% La2O3) (Plansee)
      AM_DATA(14)=17
      AM_TEMP(14, 1)=     0.+273.15
      AM_TEMP(14, 2)=    50.+273.15
      AM_TEMP(14, 3)=   100.+273.15
      AM_TEMP(14, 4)=   200.+273.15
      AM_TEMP(14, 5)=   300.+273.15
      AM_TEMP(14, 6)=   400.+273.15
      AM_TEMP(14, 7)=   500.+273.15
      AM_TEMP(14, 8)=   600.+273.15
      AM_TEMP(14, 9)=   700.+273.15
      AM_TEMP(14,10)=   800.+273.15
      AM_TEMP(14,11)=   900.+273.15
      AM_TEMP(14,12)=  1000.+273.15
      AM_TEMP(14,13)=  1100.+273.15
      AM_TEMP(14,14)=  1200.+273.15
      AM_TEMP(14,15)=  1300.+273.15
      AM_TEMP(14,16)=  1400.+273.15
      AM_TEMP(14,17)=  2500.+273.15
      AM_CP  (14, 1)=   122.3
      AM_CP  (14, 2)=   130.8
      AM_CP  (14, 3)=   139.3
      AM_CP  (14, 4)=   142.6
      AM_CP  (14, 5)=   143.7
      AM_CP  (14, 6)=   145.3
      AM_CP  (14, 7)=   145.9
      AM_CP  (14, 8)=   147.5
      AM_CP  (14, 9)=   148.6
      AM_CP  (14,10)=   150.2
      AM_CP  (14,11)=   151.6
      AM_CP  (14,12)=   152.5
      AM_CP  (14,13)=   153.4
      AM_CP  (14,14)=   154.9
      AM_CP  (14,15)=   155.5
      AM_CP  (14,16)=   154.8
      AM_CP  (14,17)=   147.1
      AM_TCI (14, 1)=   123.
      AM_TCI (14, 2)=   121.7
      AM_TCI (14, 3)=   120.4
      AM_TCI (14, 4)=   117.8
      AM_TCI (14, 5)=   113.6
      AM_TCI (14, 6)=   109.
      AM_TCI (14, 7)=   105.8
      AM_TCI (14, 8)=   102.9
      AM_TCI (14, 9)=   102.8
      AM_TCI (14,10)=   100.3
      AM_TCI (14,11)=   100.7
      AM_TCI (14,12)=    98.5
      AM_TCI (14,13)=    96.2
      AM_TCI (14,14)=    94.8
      AM_TCI (14,15)=    94.4
      AM_TCI (14,16)=    94.2
      AM_TCI (14,17)=    92.
      AM_TCJ (14, 1)=   123.
      AM_TCJ (14, 2)=   121.7
      AM_TCJ (14, 3)=   120.4
      AM_TCJ (14, 4)=   117.8
      AM_TCJ (14, 5)=   113.6
      AM_TCJ (14, 6)=   109.
      AM_TCJ (14, 7)=   105.8
      AM_TCJ (14, 8)=   102.9
      AM_TCJ (14, 9)=   102.8
      AM_TCJ (14,10)=   100.3
      AM_TCJ (14,11)=   100.7
      AM_TCJ (14,12)=    98.5
      AM_TCJ (14,13)=    96.2
      AM_TCJ (14,14)=    94.8
      AM_TCJ (14,15)=    94.4
      AM_TCJ (14,16)=    94.2
      AM_TCJ (14,17)=    92.
      AM_RO  (14, 1)= 19300.
      AM_RO  (14, 2)= 19300.
      AM_RO  (14, 3)= 19300.
      AM_RO  (14, 4)= 19300.
      AM_RO  (14, 5)= 19300.
      AM_RO  (14, 6)= 19300.
      AM_RO  (14, 7)= 19300.
      AM_RO  (14, 8)= 19300.
      AM_RO  (14, 9)= 19300.
      AM_RO  (14,10)= 19300.
      AM_RO  (14,11)= 19300.
      AM_RO  (14,12)= 19300.
      AM_RO  (14,13)= 19300.
      AM_RO  (14,14)= 19300.
      AM_RO  (14,15)= 19300.
      AM_RO  (14,16)= 19300.
      AM_RO  (14,17)= 19300.

! graphite Toyo Tanso IG-11
      AM_DATA(15)=13
      AM_TEMP(15,1)=     0.+273.15
      AM_TEMP(15,2)=   100.+273.15
      AM_TEMP(15,3)=   200.+273.15
      AM_TEMP(15,4)=   300.+273.15
      AM_TEMP(15,5)=   400.+273.15
      AM_TEMP(15,6)=   500.+273.15
      AM_TEMP(15,7)=   600.+273.15
      AM_TEMP(15,8)=   700.+273.15
      AM_TEMP(15,9)=   800.+273.15
      AM_TEMP(15,10)=  900.+273.15
      AM_TEMP(15,11)= 1000.+273.15
      AM_TEMP(15,12)= 1100.+273.15
      AM_TEMP(15,13)= 2500.+273.15

      AM_CP  (15,1)=   751.6
      AM_CP  (15,2)=   977.7
      AM_CP  (15,3)=  1203.7
      AM_CP  (15,4)=  1387.8
      AM_CP  (15,5)=  1508.4
      AM_CP  (15,6)=  1628.9
      AM_CP  (15,7)=  1688.7
      AM_CP  (15,8)=  1711.3
      AM_CP  (15,9)=  1733.9
      AM_CP  (15,10)= 1756.5
      AM_CP  (15,11)= 1779.2
      AM_CP  (15,12)= 1801.1
      AM_CP  (15,13)= 1919.

      AM_TCI (15,1)=   117.9
      AM_TCI (15,2)=   106.4
      AM_TCI (15,3)=    97.
      AM_TCI (15,4)=    87.1
      AM_TCI (15,5)=    79.3
      AM_TCI (15,6)=    72.3
      AM_TCI (15,7)=    66.6
      AM_TCI (15,8)=    61.2
      AM_TCI (15,9)=    57.1
      AM_TCI (15,10)=   53.
      AM_TCI (15,11)=   49.3
      AM_TCI (15,12)=   46.4
      AM_TCI (15,13)=   41.5

      AM_TCJ (15,1)=   117.9
      AM_TCJ (15,2)=   106.4
      AM_TCJ (15,3)=    97.
      AM_TCJ (15,4)=    87.1
      AM_TCJ (15,5)=    79.3
      AM_TCJ (15,6)=    72.3
      AM_TCJ (15,7)=    66.6
      AM_TCJ (15,8)=    61.2
      AM_TCJ (15,9)=    57.1
      AM_TCJ (15,10)=   53.
      AM_TCJ (15,11)=   49.3
      AM_TCJ (15,12)=   46.4
      AM_TCJ (15,13)=   41.5

      AM_RO  (15,1)=  1770.
      AM_RO  (15,2)=  1770.
      AM_RO  (15,3)=  1770.
      AM_RO  (15,4)=  1770.
      AM_RO  (15,5)=  1770.
      AM_RO  (15,6)=  1770.
      AM_RO  (15,7)=  1770.
      AM_RO  (15,8)=  1770.
      AM_RO  (15,9)=  1770.
      AM_RO  (15,10)= 1770.
      AM_RO  (15,11)= 1770.
      AM_RO  (15,12)= 1770.
      AM_RO  (15,13)= 1770.
! C-C/SiC DLR materiale
      AM_DATA(16)=5
      AM_TEMP(16,1)=     0.             !lagt inn kunstig
      AM_TEMP(16,2)=   473.15
      AM_TEMP(16,3)=  1273.15
      AM_TEMP(16,4)=  1923.15
      AM_TEMP(16,5)=  5000.             ! lagt in kunstig

      AM_CP  (16,1)=   748.
      AM_CP  (16,2)=   748.
      AM_CP  (16,3)=  1414.
      AM_CP  (16,4)=  1514.
      AM_CP  (16,5)=  1514.

      AM_TCI (16,1)=   16.8        !langs fiber
      AM_TCI (16,2)=   16.8
      AM_TCI (16,3)=   18.
      AM_TCI (16,4)=   16.8
      AM_TCI (16,5)=   16.8

      AM_TCJ (16,1)=   9.2        !normalt til fiber
      AM_TCJ (16,2)=   9.2
      AM_TCJ (16,3)=   7.6
      AM_TCJ (16,4)=   7.5
      AM_TCJ (16,5)=   7.5

      AM_RO  (16,1)=  2000.
      AM_RO  (16,2)=  2000.
      AM_RO  (16,3)=  2000.
      AM_RO  (16,4)=  2000.
      AM_RO  (16,5)=  2000.

      RETURN
      END


